import { Logger } from "../models";
import { ViewEngine, ComponentOption } from "../abstracts";
import { TErrorHandler, TGuard, TSessionStore, TShield, TTaskScheduler, TWall, TXmlParser } from "../types";
import { IScheduleTaskInput, IDtoValidator, IEtagOption, IFolderMap, ICacheStore } from "../interfaces";
import { CacheManager } from "../utils";
export declare class FortGlobal {
    port: number;
    viewPath: any;
    shouldParseCookie: boolean;
    shouldEnableCache: boolean;
    shouldParseBody: boolean;
    sessionStore: TSessionStore;
    cacheStore: ICacheStore;
    sessionTimeOut: number;
    viewEngine: ViewEngine;
    walls: TWall[];
    errorHandler: TErrorHandler;
    cronJobScheduler: TTaskScheduler;
    keepAliveTimeout: number;
    private shields;
    private guards;
    addGuards(guards: TGuard[]): void;
    addShields(shields: TShield[]): void;
    appName: string;
    eTag: IEtagOption;
    folders: IFolderMap[];
    appSessionIdentifier: string;
    xmlParser: TXmlParser;
    logger: Logger;
    validator: IDtoValidator;
    crons: IScheduleTaskInput[];
    get isDevelopment(): boolean;
    get isProduction(): boolean;
    componentOption: ComponentOption;
    cacheManager: CacheManager;
    setDefault(): void;
}
export declare const FORT_GLOBAL: FortGlobal;
