/*!
 * @license :fortjs - V2.8.1 - 28/02/2024
 * https://github.com/ujjwalguptaofficial/fortjs
 * Copyright (c) 2024 @Ujjwal Gupta; Licensed MIT
 */
/******/ (() => { // webpackBootstrap
/******/ 	"use strict";
/******/ 	var __webpack_modules__ = ({

/***/ "./src/abstracts/component.ts":
/*!************************************!*\
  !*** ./src/abstracts/component.ts ***!
  \************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   Component: () => (/* binding */ Component)
/* harmony export */ });
class Component {
    get request() {
        return this.componentProp_.request;
    }
    get response() {
        return this.componentProp_.response;
    }
    get query() {
        return this.componentProp_.query;
    }
    get session() {
        return this.componentProp_.session;
    }
    get cookie() {
        return this.componentProp_.cookie;
    }
    get data() {
        return this.componentProp_.data;
    }
    get logger() {
        return this.componentProp_.global.logger;
    }
    get option() {
        return this.componentProp_.global['componentOption_'];
    }
    get cache() {
        return this.componentProp_.cache;
    }
    middleware(middleware) {
        return {
            execute: () => {
                return new Promise((res, rej) => {
                    middleware(this.request, this.response, (err) => {
                        if (err) {
                            rej(err);
                        }
                        else {
                            res();
                        }
                    });
                });
            }
        };
    }
}


/***/ }),

/***/ "./src/abstracts/component_option.ts":
/*!*******************************************!*\
  !*** ./src/abstracts/component_option.ts ***!
  \*******************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   ComponentOption: () => (/* binding */ ComponentOption)
/* harmony export */ });
class ComponentOption {
    toModel(expectedClass, from) {
        const result = new expectedClass();
        for (const prop in result) {
            result[prop] = from[prop];
        }
        return result;
    }
    extractHash(expectedHash, from) {
        for (const prop in expectedHash) {
            expectedHash[prop] = from[prop];
        }
        return expectedHash;
    }
    isNull(value) {
        return value == null;
    }
    isNullOrEmpty(value) {
        return value == null || value.length === 0;
    }
    isEmpty(value) {
        return value.length === 0;
    }
}


/***/ }),

/***/ "./src/abstracts/controller.ts":
/*!*************************************!*\
  !*** ./src/abstracts/controller.ts ***!
  \*************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   Controller: () => (/* binding */ Controller)
/* harmony export */ });
/* harmony import */ var _helpers__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ../helpers */ "./src/helpers/index.ts");
/* harmony import */ var _component__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ./component */ "./src/abstracts/component.ts");


class Controller extends _component__WEBPACK_IMPORTED_MODULE_1__.Component {
    get body() {
        return this['componentProp_'].body;
    }
    get param() {
        return this['componentProp_'].param;
    }
    get file() {
        return this['componentProp_'].file;
    }
    // eslint-disable-next-line
    constructor(...args) {
        super();
    }
    initialize(data) {
        (0,_helpers__WEBPACK_IMPORTED_MODULE_0__.initController)(this, data);
    }
}


/***/ }),

/***/ "./src/abstracts/cron_task.ts":
/*!************************************!*\
  !*** ./src/abstracts/cron_task.ts ***!
  \************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   ScheduleTask: () => (/* binding */ ScheduleTask)
/* harmony export */ });
class ScheduleTask {
    constructor(name, expression, appGlobal_) {
        this.appGlobal_ = appGlobal_;
        this.name = name || this.constructor.name;
        this.expression = expression;
        this.taskScheduler_ = new appGlobal_.cronJobScheduler(this);
    }
    scheduleTask() {
        return this.taskScheduler_.start();
    }
    haltTask() {
        return this.taskScheduler_.stop();
    }
    start() {
        this.scheduleTask();
    }
    stop() {
        return this.haltTask();
    }
    // eslint-disable-next-line
    onComplete() {
    }
}


/***/ }),

/***/ "./src/abstracts/guard.ts":
/*!********************************!*\
  !*** ./src/abstracts/guard.ts ***!
  \********************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   Guard: () => (/* binding */ Guard)
/* harmony export */ });
/* harmony import */ var _helpers__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ../helpers */ "./src/helpers/index.ts");
/* harmony import */ var _component__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ./component */ "./src/abstracts/component.ts");


class Guard extends _component__WEBPACK_IMPORTED_MODULE_1__.Component {
    get body() {
        return this['componentProp_'].body;
    }
    get param() {
        return this['componentProp_'].param;
    }
    get file() {
        return this['componentProp_'].file;
    }
    get workerName() {
        return this['componentProp_'].workerInfo.workerName;
    }
    // eslint-disable-next-line
    constructor(...args) {
        super();
    }
    initialize(data) {
        return (0,_helpers__WEBPACK_IMPORTED_MODULE_0__.initGuard)(this, data);
    }
}


/***/ }),

/***/ "./src/abstracts/index.ts":
/*!********************************!*\
  !*** ./src/abstracts/index.ts ***!
  \********************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   ComponentOption: () => (/* reexport safe */ _component_option__WEBPACK_IMPORTED_MODULE_7__.ComponentOption),
/* harmony export */   Controller: () => (/* reexport safe */ _controller__WEBPACK_IMPORTED_MODULE_0__.Controller),
/* harmony export */   Guard: () => (/* reexport safe */ _guard__WEBPACK_IMPORTED_MODULE_2__.Guard),
/* harmony export */   ResultMapper: () => (/* reexport safe */ _result_mapper__WEBPACK_IMPORTED_MODULE_6__.ResultMapper),
/* harmony export */   ScheduleTask: () => (/* reexport safe */ _cron_task__WEBPACK_IMPORTED_MODULE_8__.ScheduleTask),
/* harmony export */   Shield: () => (/* reexport safe */ _shield__WEBPACK_IMPORTED_MODULE_1__.Shield),
/* harmony export */   ViewEngine: () => (/* reexport safe */ _view_engine__WEBPACK_IMPORTED_MODULE_3__.ViewEngine),
/* harmony export */   Wall: () => (/* reexport safe */ _wall__WEBPACK_IMPORTED_MODULE_4__.Wall),
/* harmony export */   XmlParser: () => (/* reexport safe */ _xml_parser__WEBPACK_IMPORTED_MODULE_5__.XmlParser)
/* harmony export */ });
/* harmony import */ var _controller__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ./controller */ "./src/abstracts/controller.ts");
/* harmony import */ var _shield__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ./shield */ "./src/abstracts/shield.ts");
/* harmony import */ var _guard__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! ./guard */ "./src/abstracts/guard.ts");
/* harmony import */ var _view_engine__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! ./view_engine */ "./src/abstracts/view_engine.ts");
/* harmony import */ var _wall__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! ./wall */ "./src/abstracts/wall.ts");
/* harmony import */ var _xml_parser__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(/*! ./xml_parser */ "./src/abstracts/xml_parser.ts");
/* harmony import */ var _result_mapper__WEBPACK_IMPORTED_MODULE_6__ = __webpack_require__(/*! ./result_mapper */ "./src/abstracts/result_mapper.ts");
/* harmony import */ var _component_option__WEBPACK_IMPORTED_MODULE_7__ = __webpack_require__(/*! ./component_option */ "./src/abstracts/component_option.ts");
/* harmony import */ var _cron_task__WEBPACK_IMPORTED_MODULE_8__ = __webpack_require__(/*! ./cron_task */ "./src/abstracts/cron_task.ts");











/***/ }),

/***/ "./src/abstracts/result_mapper.ts":
/*!****************************************!*\
  !*** ./src/abstracts/result_mapper.ts ***!
  \****************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   ResultMapper: () => (/* binding */ ResultMapper)
/* harmony export */ });
class ResultMapper {
}


/***/ }),

/***/ "./src/abstracts/shield.ts":
/*!*********************************!*\
  !*** ./src/abstracts/shield.ts ***!
  \*********************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   Shield: () => (/* binding */ Shield)
/* harmony export */ });
/* harmony import */ var _helpers__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ../helpers */ "./src/helpers/index.ts");
/* harmony import */ var _component__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ./component */ "./src/abstracts/component.ts");


class Shield extends _component__WEBPACK_IMPORTED_MODULE_1__.Component {
    get workerName() {
        return this['componentProp_'].workerInfo.workerName;
    }
    // eslint-disable-next-line
    constructor(...args) {
        super();
    }
    initialize(data) {
        return (0,_helpers__WEBPACK_IMPORTED_MODULE_0__.initShield)(this, data);
    }
}


/***/ }),

/***/ "./src/abstracts/view_engine.ts":
/*!**************************************!*\
  !*** ./src/abstracts/view_engine.ts ***!
  \**************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   ViewEngine: () => (/* binding */ ViewEngine)
/* harmony export */ });
class ViewEngine {
}


/***/ }),

/***/ "./src/abstracts/wall.ts":
/*!*******************************!*\
  !*** ./src/abstracts/wall.ts ***!
  \*******************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   Wall: () => (/* binding */ Wall)
/* harmony export */ });
/* harmony import */ var _helpers__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ../helpers */ "./src/helpers/index.ts");
/* harmony import */ var _component__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ./component */ "./src/abstracts/component.ts");


class Wall extends _component__WEBPACK_IMPORTED_MODULE_1__.Component {
    // eslint-disable-next-line
    onOutgoing(finalResult, ...args) {
    }
    // eslint-disable-next-line
    constructor(...args) {
        super();
    }
    initialize(data) {
        return (0,_helpers__WEBPACK_IMPORTED_MODULE_0__.initWall)(this, data);
    }
}


/***/ }),

/***/ "./src/abstracts/xml_parser.ts":
/*!*************************************!*\
  !*** ./src/abstracts/xml_parser.ts ***!
  \*************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   XmlParser: () => (/* binding */ XmlParser)
/* harmony export */ });
class XmlParser {
}


/***/ }),

/***/ "./src/constants/index.ts":
/*!********************************!*\
  !*** ./src/constants/index.ts ***!
  \********************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   APP_NAME: () => (/* binding */ APP_NAME),
/* harmony export */   CONSTRUCTOR: () => (/* binding */ CONSTRUCTOR),
/* harmony export */   CONTENT_LENGTH: () => (/* binding */ CONTENT_LENGTH),
/* harmony export */   CONTENT_TYPE: () => (/* binding */ CONTENT_TYPE),
/* harmony export */   COOKIE: () => (/* binding */ COOKIE),
/* harmony export */   CURRENT_PATH: () => (/* binding */ CURRENT_PATH),
/* harmony export */   FROM_CACHE: () => (/* binding */ FROM_CACHE),
/* harmony export */   SET_COOKIE: () => (/* binding */ SET_COOKIE)
/* harmony export */ });
const CONTENT_TYPE = "Content-Type";
const APP_NAME = "fort";
const COOKIE = "Cookie";
const SET_COOKIE = 'Set-Cookie';
const CURRENT_PATH = process.cwd();
const CONTENT_LENGTH = "Content-Length";
const CONSTRUCTOR = "const_constructor";
const FROM_CACHE = "__FORT_FROM_CACHE__";


/***/ }),

/***/ "./src/decorators/assign.ts":
/*!**********************************!*\
  !*** ./src/decorators/assign.ts ***!
  \**********************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   assign: () => (/* binding */ assign)
/* harmony export */ });
/* harmony import */ var _handlers__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ../handlers */ "./src/handlers/index.ts");
/* harmony import */ var _constants__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ../constants */ "./src/constants/index.ts");


const assign = (value) => {
    return (target, methodName, paramIndex) => {
        const className = target.name || target.constructor.name;
        if (methodName == null) {
            methodName = _constants__WEBPACK_IMPORTED_MODULE_1__.CONSTRUCTOR;
        }
        _handlers__WEBPACK_IMPORTED_MODULE_0__.InjectorHandler.addWorkerValue(className, methodName, paramIndex, value);
    };
};


/***/ }),

/***/ "./src/decorators/body.ts":
/*!********************************!*\
  !*** ./src/decorators/body.ts ***!
  \********************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   asBody: () => (/* binding */ asBody),
/* harmony export */   asParam: () => (/* binding */ asParam),
/* harmony export */   asQuery: () => (/* binding */ asQuery)
/* harmony export */ });
/* harmony import */ var _assign__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ./assign */ "./src/decorators/assign.ts");

const createBodyInjectParam = (type, prop) => {
    return {
        "__fortReqType__": type,
        inject: (controller) => {
            return controller[prop];
        }
    };
};
function asBody(target, propertyKey, parameterIndex) {
    (0,_assign__WEBPACK_IMPORTED_MODULE_0__.assign)(createBodyInjectParam("body", "body"))(target, propertyKey, parameterIndex);
}
function asQuery(target, methodName, paramIndex) {
    (0,_assign__WEBPACK_IMPORTED_MODULE_0__.assign)(createBodyInjectParam("query", "query"))(target, methodName, paramIndex);
}
function asParam(target, methodName, paramIndex) {
    (0,_assign__WEBPACK_IMPORTED_MODULE_0__.assign)(createBodyInjectParam("param", "param"))(target, methodName, paramIndex);
}


/***/ }),

/***/ "./src/decorators/cache.ts":
/*!*********************************!*\
  !*** ./src/decorators/cache.ts ***!
  \*********************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   cacheFor: () => (/* binding */ cacheFor)
/* harmony export */ });
/* harmony import */ var _handlers__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ../handlers */ "./src/handlers/index.ts");

/**
 *
 *
 * @param {number} ttl - time to live in second.
 * @param {ICacheOption} option
 * @return {*}  {MethodDecorator}
 */
const cacheFor = (ttl, option = {}) => {
    return ((target, methodName) => {
        const className = target.constructor.name;
        _handlers__WEBPACK_IMPORTED_MODULE_0__.RouteHandler.addCache({
            param: option.param,
            query: option.query,
            ttl,
            key: option.key || className + "_" + methodName
        }, className, methodName);
    });
};


/***/ }),

/***/ "./src/decorators/default_worker.ts":
/*!******************************************!*\
  !*** ./src/decorators/default_worker.ts ***!
  \******************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   defaultWorker: () => (/* binding */ defaultWorker)
/* harmony export */ });
/* harmony import */ var _enums__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ../enums */ "./src/enums/index.ts");
/* harmony import */ var _route__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ./route */ "./src/decorators/route.ts");
/* harmony import */ var _worker__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! ./worker */ "./src/decorators/worker.ts");
/* harmony import */ var _wrap_method_decorator__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! ./wrap_method_decorator */ "./src/decorators/wrap_method_decorator.ts");




function defaultWorker(...args) {
    return (0,_wrap_method_decorator__WEBPACK_IMPORTED_MODULE_3__.wrapMethodDecorator)(args, createWorker);
}
function createWorker(target, methodName, ...allowedMethods) {
    const args = (allowedMethods.length === 0 ? [_enums__WEBPACK_IMPORTED_MODULE_0__.HTTP_METHOD.Get] : allowedMethods);
    (0,_worker__WEBPACK_IMPORTED_MODULE_2__.worker)(...args)(target, methodName, null);
    (0,_route__WEBPACK_IMPORTED_MODULE_1__.route)("/")(target, methodName, null);
}


/***/ }),

/***/ "./src/decorators/guards.ts":
/*!**********************************!*\
  !*** ./src/decorators/guards.ts ***!
  \**********************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   guards: () => (/* binding */ guards)
/* harmony export */ });
/* harmony import */ var _handlers__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ../handlers */ "./src/handlers/index.ts");

const guards = (...value) => {
    return ((target, methodName) => {
        const className = target.constructor.name;
        _handlers__WEBPACK_IMPORTED_MODULE_0__.RouteHandler.addGuards(value, className, methodName);
    });
};


/***/ }),

/***/ "./src/decorators/index.ts":
/*!*********************************!*\
  !*** ./src/decorators/index.ts ***!
  \*********************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   asBody: () => (/* reexport safe */ _body__WEBPACK_IMPORTED_MODULE_8__.asBody),
/* harmony export */   asParam: () => (/* reexport safe */ _body__WEBPACK_IMPORTED_MODULE_8__.asParam),
/* harmony export */   asQuery: () => (/* reexport safe */ _body__WEBPACK_IMPORTED_MODULE_8__.asQuery),
/* harmony export */   assign: () => (/* reexport safe */ _assign__WEBPACK_IMPORTED_MODULE_5__.assign),
/* harmony export */   cacheFor: () => (/* reexport safe */ _cache__WEBPACK_IMPORTED_MODULE_10__.cacheFor),
/* harmony export */   defaultWorker: () => (/* reexport safe */ _default_worker__WEBPACK_IMPORTED_MODULE_4__.defaultWorker),
/* harmony export */   guards: () => (/* reexport safe */ _guards__WEBPACK_IMPORTED_MODULE_2__.guards),
/* harmony export */   http: () => (/* reexport safe */ _req_method__WEBPACK_IMPORTED_MODULE_9__.http),
/* harmony export */   route: () => (/* reexport safe */ _route__WEBPACK_IMPORTED_MODULE_3__.route),
/* harmony export */   shields: () => (/* reexport safe */ _shields__WEBPACK_IMPORTED_MODULE_1__.shields),
/* harmony export */   singleton: () => (/* reexport safe */ _singleton__WEBPACK_IMPORTED_MODULE_6__.singleton),
/* harmony export */   validate: () => (/* reexport safe */ _validate__WEBPACK_IMPORTED_MODULE_7__.validate),
/* harmony export */   worker: () => (/* reexport safe */ _worker__WEBPACK_IMPORTED_MODULE_0__.worker)
/* harmony export */ });
/* harmony import */ var _worker__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ./worker */ "./src/decorators/worker.ts");
/* harmony import */ var _shields__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ./shields */ "./src/decorators/shields.ts");
/* harmony import */ var _guards__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! ./guards */ "./src/decorators/guards.ts");
/* harmony import */ var _route__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! ./route */ "./src/decorators/route.ts");
/* harmony import */ var _default_worker__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! ./default_worker */ "./src/decorators/default_worker.ts");
/* harmony import */ var _assign__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(/*! ./assign */ "./src/decorators/assign.ts");
/* harmony import */ var _singleton__WEBPACK_IMPORTED_MODULE_6__ = __webpack_require__(/*! ./singleton */ "./src/decorators/singleton.ts");
/* harmony import */ var _validate__WEBPACK_IMPORTED_MODULE_7__ = __webpack_require__(/*! ./validate */ "./src/decorators/validate.ts");
/* harmony import */ var _body__WEBPACK_IMPORTED_MODULE_8__ = __webpack_require__(/*! ./body */ "./src/decorators/body.ts");
/* harmony import */ var _req_method__WEBPACK_IMPORTED_MODULE_9__ = __webpack_require__(/*! ./req_method */ "./src/decorators/req_method.ts");
/* harmony import */ var _cache__WEBPACK_IMPORTED_MODULE_10__ = __webpack_require__(/*! ./cache */ "./src/decorators/cache.ts");













/***/ }),

/***/ "./src/decorators/req_method.ts":
/*!**************************************!*\
  !*** ./src/decorators/req_method.ts ***!
  \**************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   http: () => (/* binding */ http)
/* harmony export */ });
/* harmony import */ var _enums__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ../enums */ "./src/enums/index.ts");
/* harmony import */ var _route__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ./route */ "./src/decorators/route.ts");
/* harmony import */ var _worker__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! ./worker */ "./src/decorators/worker.ts");
/* harmony import */ var _wrap_method_decorator__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! ./wrap_method_decorator */ "./src/decorators/wrap_method_decorator.ts");




function get(...args) {
    return (0,_wrap_method_decorator__WEBPACK_IMPORTED_MODULE_3__.wrapMethodDecorator)(args, createWorkerForGet);
}
function post(...args) {
    return (0,_wrap_method_decorator__WEBPACK_IMPORTED_MODULE_3__.wrapMethodDecorator)(args, createWorkerForPost);
}
function del(...args) {
    return (0,_wrap_method_decorator__WEBPACK_IMPORTED_MODULE_3__.wrapMethodDecorator)(args, createWorkerForDelete);
}
function patch(...args) {
    return (0,_wrap_method_decorator__WEBPACK_IMPORTED_MODULE_3__.wrapMethodDecorator)(args, createWorkerForPatch);
}
function put(...args) {
    return (0,_wrap_method_decorator__WEBPACK_IMPORTED_MODULE_3__.wrapMethodDecorator)(args, createWorkerForPut);
}
function registerWorkerAndCreate(target, methodName, httpMethod, routes) {
    const routeArg = (routes.length === 0 ? null : routes[0]);
    (0,_worker__WEBPACK_IMPORTED_MODULE_2__.worker)(httpMethod)(target, methodName, null);
    (0,_route__WEBPACK_IMPORTED_MODULE_1__.route)(routeArg)(target, methodName, null);
}
function createWorkerForGet(target, methodName, ...routes) {
    registerWorkerAndCreate(target, methodName, _enums__WEBPACK_IMPORTED_MODULE_0__.HTTP_METHOD.Get, routes);
}
function createWorkerForPost(target, methodName, ...routes) {
    registerWorkerAndCreate(target, methodName, _enums__WEBPACK_IMPORTED_MODULE_0__.HTTP_METHOD.Post, routes);
}
function createWorkerForPatch(target, methodName, ...routes) {
    registerWorkerAndCreate(target, methodName, _enums__WEBPACK_IMPORTED_MODULE_0__.HTTP_METHOD.Patch, routes);
}
function createWorkerForPut(target, methodName, ...routes) {
    registerWorkerAndCreate(target, methodName, _enums__WEBPACK_IMPORTED_MODULE_0__.HTTP_METHOD.Put, routes);
}
function createWorkerForDelete(target, methodName, ...routes) {
    registerWorkerAndCreate(target, methodName, _enums__WEBPACK_IMPORTED_MODULE_0__.HTTP_METHOD.Delete, routes);
}
const http = {
    get, post, delete: del,
    patch, put
};


/***/ }),

/***/ "./src/decorators/route.ts":
/*!*********************************!*\
  !*** ./src/decorators/route.ts ***!
  \*********************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   route: () => (/* binding */ route)
/* harmony export */ });
/* harmony import */ var _handlers__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ../handlers */ "./src/handlers/index.ts");
/* harmony import */ var _helpers__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ../helpers */ "./src/helpers/index.ts");


const route = (format) => {
    return ((target, methodName) => {
        const className = target.constructor.name;
        // remove / from route
        if (format != null) {
            format = (0,_helpers__WEBPACK_IMPORTED_MODULE_1__.removeLastSlash)(format);
        }
        _handlers__WEBPACK_IMPORTED_MODULE_0__.RouteHandler.addPattern(format, className, methodName);
    });
};


/***/ }),

/***/ "./src/decorators/shields.ts":
/*!***********************************!*\
  !*** ./src/decorators/shields.ts ***!
  \***********************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   shields: () => (/* binding */ shields)
/* harmony export */ });
/* harmony import */ var _handlers__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ../handlers */ "./src/handlers/index.ts");

const shields = (...shields) => {
    return (target) => {
        const className = target.name;
        _handlers__WEBPACK_IMPORTED_MODULE_0__.RouteHandler.addShields(shields, className);
    };
};


/***/ }),

/***/ "./src/decorators/singleton.ts":
/*!*************************************!*\
  !*** ./src/decorators/singleton.ts ***!
  \*************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   singleton: () => (/* binding */ singleton)
/* harmony export */ });
/* harmony import */ var _handlers__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ../handlers */ "./src/handlers/index.ts");
/* harmony import */ var _constants__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ../constants */ "./src/constants/index.ts");


const singleton = (value) => {
    return (target, methodName, paramIndex) => {
        const className = target.name || target.constructor.name;
        if (methodName == null || methodName === 'constructor') {
            methodName = _constants__WEBPACK_IMPORTED_MODULE_1__.CONSTRUCTOR;
        }
        _handlers__WEBPACK_IMPORTED_MODULE_0__.InjectorHandler.addSingleton(className, methodName, paramIndex, value);
    };
};


/***/ }),

/***/ "./src/decorators/validate.ts":
/*!************************************!*\
  !*** ./src/decorators/validate.ts ***!
  \************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   validate: () => (/* binding */ validate)
/* harmony export */ });
/* harmony import */ var _handlers__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ../handlers */ "./src/handlers/index.ts");
/* harmony import */ var _helpers__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ../helpers */ "./src/helpers/index.ts");


const validate = {
    body: function (value) {
        return (target, methodName) => {
            const className = (0,_helpers__WEBPACK_IMPORTED_MODULE_1__.getClassName)(target);
            _handlers__WEBPACK_IMPORTED_MODULE_0__.RouteHandler.addExpected("body", className, methodName, value);
            _handlers__WEBPACK_IMPORTED_MODULE_0__.RouteHandler.addGuards([_helpers__WEBPACK_IMPORTED_MODULE_1__.ValidateBodyGuard], className, methodName);
        };
    },
    param: function (value) {
        return (target, methodName) => {
            const className = (0,_helpers__WEBPACK_IMPORTED_MODULE_1__.getClassName)(target);
            _handlers__WEBPACK_IMPORTED_MODULE_0__.RouteHandler.addExpected("param", className, methodName, value);
            _handlers__WEBPACK_IMPORTED_MODULE_0__.RouteHandler.addGuards([_helpers__WEBPACK_IMPORTED_MODULE_1__.ValidateParamGuard], className, methodName);
        };
    },
    query: function (value) {
        return (target, methodName) => {
            const className = (0,_helpers__WEBPACK_IMPORTED_MODULE_1__.getClassName)(target);
            _handlers__WEBPACK_IMPORTED_MODULE_0__.RouteHandler.addExpected("query", className, methodName, value);
            _handlers__WEBPACK_IMPORTED_MODULE_0__.RouteHandler.addShields([_helpers__WEBPACK_IMPORTED_MODULE_1__.ValidateQueryShield], className);
        };
    }
};


/***/ }),

/***/ "./src/decorators/worker.ts":
/*!**********************************!*\
  !*** ./src/decorators/worker.ts ***!
  \**********************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   worker: () => (/* binding */ worker)
/* harmony export */ });
/* harmony import */ var _enums__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ../enums */ "./src/enums/index.ts");
/* harmony import */ var _handlers__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ../handlers */ "./src/handlers/index.ts");
/* harmony import */ var _wrap_method_decorator__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! ./wrap_method_decorator */ "./src/decorators/wrap_method_decorator.ts");



function worker(...args) {
    return (0,_wrap_method_decorator__WEBPACK_IMPORTED_MODULE_2__.wrapMethodDecorator)(args, createWorker);
}
const allHttpMethod = [
    _enums__WEBPACK_IMPORTED_MODULE_0__.HTTP_METHOD.Delete,
    _enums__WEBPACK_IMPORTED_MODULE_0__.HTTP_METHOD.Get,
    _enums__WEBPACK_IMPORTED_MODULE_0__.HTTP_METHOD.Post,
    _enums__WEBPACK_IMPORTED_MODULE_0__.HTTP_METHOD.Patch,
    _enums__WEBPACK_IMPORTED_MODULE_0__.HTTP_METHOD.Put
];
function createWorker(target, methodName, ...allowedMethods) {
    const className = target.constructor.name;
    const actionInfo = {
        workerName: methodName,
        methodsAllowed: allowedMethods.length === 0 ? allHttpMethod : allowedMethods,
        guards: [],
        pattern: `/${methodName.toLowerCase()}`,
        values: []
    };
    _handlers__WEBPACK_IMPORTED_MODULE_1__.RouteHandler.addWorker(actionInfo, className);
}


/***/ }),

/***/ "./src/decorators/wrap_method_decorator.ts":
/*!*************************************************!*\
  !*** ./src/decorators/wrap_method_decorator.ts ***!
  \*************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   wrapMethodDecorator: () => (/* binding */ wrapMethodDecorator)
/* harmony export */ });
function wrapMethodDecorator(args, executor) {
    // this is executed without param
    if (args.length > 2 && args[2].writable != null) {
        const [target, propertyName] = args;
        executor(target, propertyName);
        return;
    }
    return (target, key) => {
        executor(target, key, ...args);
    };
}


/***/ }),

/***/ "./src/enums/data_type.ts":
/*!********************************!*\
  !*** ./src/enums/data_type.ts ***!
  \********************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   DATA_TYPE: () => (/* binding */ DATA_TYPE)
/* harmony export */ });
var DATA_TYPE;
(function (DATA_TYPE) {
    DATA_TYPE["String"] = "string";
    DATA_TYPE["Number"] = "number";
    DATA_TYPE["Array"] = "array";
    DATA_TYPE["Object"] = "object";
    DATA_TYPE["Function"] = "function";
})(DATA_TYPE || (DATA_TYPE = {}));


/***/ }),

/***/ "./src/enums/error_type.ts":
/*!*********************************!*\
  !*** ./src/enums/error_type.ts ***!
  \*********************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   ERROR_TYPE: () => (/* binding */ ERROR_TYPE)
/* harmony export */ });
var ERROR_TYPE;
(function (ERROR_TYPE) {
    ERROR_TYPE["InvalidControllerName"] = "invalid_controller_name";
    ERROR_TYPE["InvalidContentType"] = "invalid_content_type";
    ERROR_TYPE["PortInUse"] = "port_in_use";
    ERROR_TYPE["UndefinedViewEngine"] = "undefined_view_engine";
})(ERROR_TYPE || (ERROR_TYPE = {}));


/***/ }),

/***/ "./src/enums/etag_type.ts":
/*!********************************!*\
  !*** ./src/enums/etag_type.ts ***!
  \********************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   ETAG_TYPE: () => (/* binding */ ETAG_TYPE)
/* harmony export */ });
var ETAG_TYPE;
(function (ETAG_TYPE) {
    ETAG_TYPE["Strong"] = "strong";
    ETAG_TYPE["Weak"] = "weak";
})(ETAG_TYPE || (ETAG_TYPE = {}));


/***/ }),

/***/ "./src/enums/http_method.ts":
/*!**********************************!*\
  !*** ./src/enums/http_method.ts ***!
  \**********************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   HTTP_METHOD: () => (/* binding */ HTTP_METHOD)
/* harmony export */ });
var HTTP_METHOD;
(function (HTTP_METHOD) {
    HTTP_METHOD["Get"] = "GET";
    HTTP_METHOD["Post"] = "POST";
    HTTP_METHOD["Put"] = "PUT";
    HTTP_METHOD["Patch"] = "PATCH";
    HTTP_METHOD["Delete"] = "DELETE";
    HTTP_METHOD["Options"] = "OPTIONS";
    HTTP_METHOD["Head"] = "HEAD";
})(HTTP_METHOD || (HTTP_METHOD = {}));


/***/ }),

/***/ "./src/enums/http_result_type.ts":
/*!***************************************!*\
  !*** ./src/enums/http_result_type.ts ***!
  \***************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   HTTP_RESULT_TYPE: () => (/* binding */ HTTP_RESULT_TYPE)
/* harmony export */ });
var HTTP_RESULT_TYPE;
(function (HTTP_RESULT_TYPE) {
    HTTP_RESULT_TYPE[HTTP_RESULT_TYPE["Default"] = 0] = "Default";
    HTTP_RESULT_TYPE[HTTP_RESULT_TYPE["File"] = 1] = "File";
    HTTP_RESULT_TYPE[HTTP_RESULT_TYPE["Redirect"] = 2] = "Redirect";
    HTTP_RESULT_TYPE[HTTP_RESULT_TYPE["FormattedResult"] = 3] = "FormattedResult";
})(HTTP_RESULT_TYPE || (HTTP_RESULT_TYPE = {}));


/***/ }),

/***/ "./src/enums/http_status_code.ts":
/*!***************************************!*\
  !*** ./src/enums/http_status_code.ts ***!
  \***************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   HTTP_STATUS_CODE: () => (/* binding */ HTTP_STATUS_CODE)
/* harmony export */ });
var HTTP_STATUS_CODE;
(function (HTTP_STATUS_CODE) {
    HTTP_STATUS_CODE[HTTP_STATUS_CODE["BadRequest"] = 400] = "BadRequest";
    HTTP_STATUS_CODE[HTTP_STATUS_CODE["Unauthorized"] = 401] = "Unauthorized";
    HTTP_STATUS_CODE[HTTP_STATUS_CODE["Forbidden"] = 403] = "Forbidden";
    HTTP_STATUS_CODE[HTTP_STATUS_CODE["NotFound"] = 404] = "NotFound";
    HTTP_STATUS_CODE[HTTP_STATUS_CODE["Ok"] = 200] = "Ok";
    HTTP_STATUS_CODE[HTTP_STATUS_CODE["Created"] = 201] = "Created";
    HTTP_STATUS_CODE[HTTP_STATUS_CODE["NoContent"] = 204] = "NoContent";
    HTTP_STATUS_CODE[HTTP_STATUS_CODE["Redirect"] = 302] = "Redirect";
    HTTP_STATUS_CODE[HTTP_STATUS_CODE["NotModified"] = 304] = "NotModified";
    HTTP_STATUS_CODE[HTTP_STATUS_CODE["MethodNotAllowed"] = 405] = "MethodNotAllowed";
    HTTP_STATUS_CODE[HTTP_STATUS_CODE["NotAcceptable"] = 406] = "NotAcceptable";
    HTTP_STATUS_CODE[HTTP_STATUS_CODE["InternalServerError"] = 500] = "InternalServerError";
})(HTTP_STATUS_CODE || (HTTP_STATUS_CODE = {}));


/***/ }),

/***/ "./src/enums/index.ts":
/*!****************************!*\
  !*** ./src/enums/index.ts ***!
  \****************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   DATA_TYPE: () => (/* reexport safe */ _data_type__WEBPACK_IMPORTED_MODULE_5__.DATA_TYPE),
/* harmony export */   ERROR_TYPE: () => (/* reexport safe */ _error_type__WEBPACK_IMPORTED_MODULE_4__.ERROR_TYPE),
/* harmony export */   ETAG_TYPE: () => (/* reexport safe */ _etag_type__WEBPACK_IMPORTED_MODULE_3__.ETAG_TYPE),
/* harmony export */   HTTP_METHOD: () => (/* reexport safe */ _http_method__WEBPACK_IMPORTED_MODULE_1__.HTTP_METHOD),
/* harmony export */   HTTP_RESULT_TYPE: () => (/* reexport safe */ _http_result_type__WEBPACK_IMPORTED_MODULE_6__.HTTP_RESULT_TYPE),
/* harmony export */   HTTP_STATUS_CODE: () => (/* reexport safe */ _http_status_code__WEBPACK_IMPORTED_MODULE_2__.HTTP_STATUS_CODE),
/* harmony export */   MIME_TYPE: () => (/* reexport safe */ _mime_type__WEBPACK_IMPORTED_MODULE_0__.MIME_TYPE)
/* harmony export */ });
/* harmony import */ var _mime_type__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ./mime_type */ "./src/enums/mime_type.ts");
/* harmony import */ var _http_method__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ./http_method */ "./src/enums/http_method.ts");
/* harmony import */ var _http_status_code__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! ./http_status_code */ "./src/enums/http_status_code.ts");
/* harmony import */ var _etag_type__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! ./etag_type */ "./src/enums/etag_type.ts");
/* harmony import */ var _error_type__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! ./error_type */ "./src/enums/error_type.ts");
/* harmony import */ var _data_type__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(/*! ./data_type */ "./src/enums/data_type.ts");
/* harmony import */ var _http_result_type__WEBPACK_IMPORTED_MODULE_6__ = __webpack_require__(/*! ./http_result_type */ "./src/enums/http_result_type.ts");









/***/ }),

/***/ "./src/enums/mime_type.ts":
/*!********************************!*\
  !*** ./src/enums/mime_type.ts ***!
  \********************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   MIME_TYPE: () => (/* binding */ MIME_TYPE)
/* harmony export */ });
var MIME_TYPE;
(function (MIME_TYPE) {
    MIME_TYPE["Text"] = "text/plain";
    MIME_TYPE["Json"] = "application/json";
    MIME_TYPE["Html"] = "text/html";
    MIME_TYPE["FormUrlEncoded"] = "application/x-www-form-urlencoded";
    MIME_TYPE["Css"] = "text/css";
    MIME_TYPE["Csv"] = "text/csv";
    MIME_TYPE["Js"] = "application/javascript";
    MIME_TYPE["Bmp"] = "image/bmp";
    MIME_TYPE["Jpeg"] = "image/jpeg";
    MIME_TYPE["Gif"] = "image/gif";
    MIME_TYPE["Ico"] = "image/x-icon";
    MIME_TYPE["Png"] = "image/png";
    MIME_TYPE["Pdf"] = "application/pdf";
    MIME_TYPE["Svg"] = "image/svg+xml";
    MIME_TYPE["Rtf"] = "application/rtf";
    MIME_TYPE["Xml"] = "application/xml";
    MIME_TYPE["Xls"] = "application/vnd.ms-excel";
    MIME_TYPE["Xlsx"] = "application/vnd.openxmlformats-officedocument.spreadsheetml.sheet";
    MIME_TYPE["Ttf"] = "font/ttf";
    MIME_TYPE["Woff"] = "font/woff";
    MIME_TYPE["Woff2"] = "font/woff2";
    MIME_TYPE["Eot"] = "application/vnd.ms-fontobject";
    MIME_TYPE["Otf"] = "font/otf";
    MIME_TYPE["Swf"] = "application/x-shockwave-flash";
    MIME_TYPE["Avi"] = "video/avi";
    MIME_TYPE["FormMultiPart"] = "multipart/form-data";
})(MIME_TYPE || (MIME_TYPE = {}));


/***/ }),

/***/ "./src/extra/dto_validator.ts":
/*!************************************!*\
  !*** ./src/extra/dto_validator.ts ***!
  \************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   DtoValidator: () => (/* binding */ DtoValidator)
/* harmony export */ });
/* harmony import */ var class_validator__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! class-validator */ "class-validator");
/* harmony import */ var class_validator__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(class_validator__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _helpers__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ../helpers */ "./src/helpers/index.ts");
/* harmony import */ var _enums__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! ../enums */ "./src/enums/index.ts");



const defaultErrorResultMapper = (validationResult) => {
    return (0,_helpers__WEBPACK_IMPORTED_MODULE_1__.jsonResult)({
        error: {
            message: validationResult,
            type: "ValidationError",
        }
    }, _enums__WEBPACK_IMPORTED_MODULE_2__.HTTP_STATUS_CODE.BadRequest);
};
class DtoValidator {
    constructor(validatorOption = null, errorResultMapper = defaultErrorResultMapper) {
        // const defaultValidatorOption = {
        //     // whitelist: true,
        //     // forbidNonWhitelisted: true,
        //     // forbidUnknownValues: false
        // } as ValidatorOptions;
        this.validatorOption = validatorOption;
        // Object.assign(defaultValidatorOption, validatorOption);
        this.validatorOption = validatorOption;
        this.getErrorResult = errorResultMapper;
    }
    async validate(dtoInstance) {
        const errors = await (0,class_validator__WEBPACK_IMPORTED_MODULE_0__.validate)(dtoInstance, this.validatorOption);
        if (errors.length > 0) {
            const error = errors[0];
            const constraint = Object.keys(error.constraints)[0];
            const errMessage = error.constraints[constraint];
            if (error) {
                return errMessage;
            }
        }
    }
}


/***/ }),

/***/ "./src/extra/index.ts":
/*!****************************!*\
  !*** ./src/extra/index.ts ***!
  \****************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   DtoValidator: () => (/* reexport safe */ _dto_validator__WEBPACK_IMPORTED_MODULE_1__.DtoValidator),
/* harmony export */   MustacheViewEngine: () => (/* reexport safe */ _mustache_view_engine__WEBPACK_IMPORTED_MODULE_0__.MustacheViewEngine)
/* harmony export */ });
/* harmony import */ var _mustache_view_engine__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ./mustache_view_engine */ "./src/extra/mustache_view_engine.ts");
/* harmony import */ var _dto_validator__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ./dto_validator */ "./src/extra/dto_validator.ts");




/***/ }),

/***/ "./src/extra/mustache_view_engine.ts":
/*!*******************************************!*\
  !*** ./src/extra/mustache_view_engine.ts ***!
  \*******************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   MustacheViewEngine: () => (/* binding */ MustacheViewEngine)
/* harmony export */ });
/* harmony import */ var mustache__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! mustache */ "mustache");
/* harmony import */ var mustache__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(mustache__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _helpers__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ../helpers */ "./src/helpers/index.ts");


class MustacheViewEngine {
    render(value) {
        return (0,_helpers__WEBPACK_IMPORTED_MODULE_1__.getViewFromFile)({
            fileLocation: value.view
        }).then(viewData => {
            return mustache__WEBPACK_IMPORTED_MODULE_0__.render(viewData, value.model);
        });
    }
}


/***/ }),

/***/ "./src/handlers/file_handler.ts":
/*!**************************************!*\
  !*** ./src/handlers/file_handler.ts ***!
  \**************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   FileHandler: () => (/* binding */ FileHandler)
/* harmony export */ });
/* harmony import */ var _enums__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ../enums */ "./src/enums/index.ts");
/* harmony import */ var path__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! path */ "path");
/* harmony import */ var path__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(path__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var _constants__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! ../constants */ "./src/constants/index.ts");
/* harmony import */ var fs__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! fs */ "fs");
/* harmony import */ var fs__WEBPACK_IMPORTED_MODULE_3___default = /*#__PURE__*/__webpack_require__.n(fs__WEBPACK_IMPORTED_MODULE_3__);
/* harmony import */ var _helpers__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! ../helpers */ "./src/helpers/index.ts");
/* harmony import */ var etag__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(/*! etag */ "etag");
/* harmony import */ var etag__WEBPACK_IMPORTED_MODULE_5___default = /*#__PURE__*/__webpack_require__.n(etag__WEBPACK_IMPORTED_MODULE_5__);
/* harmony import */ var fresh__WEBPACK_IMPORTED_MODULE_6__ = __webpack_require__(/*! fresh */ "fresh");
/* harmony import */ var fresh__WEBPACK_IMPORTED_MODULE_6___default = /*#__PURE__*/__webpack_require__.n(fresh__WEBPACK_IMPORTED_MODULE_6__);
/* harmony import */ var _utils__WEBPACK_IMPORTED_MODULE_7__ = __webpack_require__(/*! ../utils */ "./src/utils/index.ts");








class FileHandler {
    constructor(requestHandler) {
        this.requestHandler = requestHandler;
    }
    getFileInfoFromUrl_(urlPath) {
        const splittedValue = urlPath.split("/");
        const fileInfo = {
            file: ""
        };
        if (splittedValue.length > 2 || !(0,_utils__WEBPACK_IMPORTED_MODULE_7__.isNullOrEmpty)(path__WEBPACK_IMPORTED_MODULE_1__.parse(urlPath).ext)) {
            fileInfo.folder = splittedValue[1];
            fileInfo.file = splittedValue.splice(2).join("/");
            return fileInfo;
        }
        fileInfo.folder = splittedValue[1];
        return fileInfo;
    }
    getFileStats_(filePath) {
        return (0,_helpers__WEBPACK_IMPORTED_MODULE_4__.promise)((res, rej) => {
            // eslint-disable-next-line
            fs__WEBPACK_IMPORTED_MODULE_3__.lstat(filePath, (err, status) => {
                if (err) {
                    if (err.code === 'ENOENT') {
                        res(null);
                    }
                    else {
                        rej(err);
                    }
                }
                else {
                    res(status);
                }
            });
        });
    }
    handleFileRequestFromAbsolutePath(absolutePath, fileType) {
        return this.getFileStats_(absolutePath).then(fileInfo => {
            if (fileInfo != null) {
                if (fileInfo.isDirectory() === true) {
                    return this.handleFileRequestForFolderPath_(absolutePath);
                }
                else {
                    return this.sendFile_(absolutePath, fileType, fileInfo);
                }
            }
            else {
                return this.requestHandler.onNotFound();
            }
        });
    }
    checkForFolderAllowAndReturnPath_(urlPath) {
        const fileInfo = this.getFileInfoFromUrl_(urlPath);
        const getAbsPath = () => {
            const folder = this.requestHandler.config['folders_'].find(qry => qry.alias === fileInfo.folder);
            if (folder != null) {
                return path__WEBPACK_IMPORTED_MODULE_1__.join(folder.path, fileInfo.file);
            }
            return null;
        };
        let absPath = getAbsPath();
        if (absPath == null) {
            fileInfo.folder = "/";
            fileInfo.file = urlPath;
            absPath = getAbsPath();
        }
        return absPath;
    }
    handleFileRequest(urlPath) {
        const extension = path__WEBPACK_IMPORTED_MODULE_1__.parse(urlPath).ext;
        const absFilePath = this.checkForFolderAllowAndReturnPath_(urlPath);
        if (absFilePath != null) {
            return this.handleFileRequestFromAbsolutePath(absFilePath, extension);
        }
        else {
            return this.requestHandler.onNotFound();
        }
    }
    /**
     * process folders handling asuuming path is folder.
     * Please check whether the file is folder before calling this function
     *
     * @private
     * @param {string} filePath
     * @param {Fs.Stats} fileInfo
     * @returns
     * @memberof FileHandler
     */
    handleFileRequestForFolderPath_(absolutePath) {
        absolutePath = path__WEBPACK_IMPORTED_MODULE_1__.join(absolutePath, "index.html");
        return this.getFileStats_(absolutePath).then(fileInfo => {
            return fileInfo != null ?
                this.sendFile_(absolutePath, _enums__WEBPACK_IMPORTED_MODULE_0__.MIME_TYPE.Html, fileInfo) :
                this.requestHandler.onNotFound();
        });
    }
    isClientHasFreshFile(lastModified, etagValue) {
        return fresh__WEBPACK_IMPORTED_MODULE_6__(this.requestHandler.request.headers, {
            'etag': etagValue,
            'last-modified': lastModified
        });
    }
    sendFileAsResponse(filePath, mimeType) {
        const handler = this.requestHandler;
        handler.response.writeHead(_enums__WEBPACK_IMPORTED_MODULE_0__.HTTP_STATUS_CODE.Ok, {
            [_constants__WEBPACK_IMPORTED_MODULE_2__.CONTENT_TYPE]: mimeType
        });
        const readStream = fs__WEBPACK_IMPORTED_MODULE_3__.createReadStream(filePath);
        // Handle non-existent file
        readStream.on('error', handler.onErrorOccured.bind(this));
        readStream.on('open', () => {
            readStream.pipe(handler.response);
        });
    }
    sendFile_(filePath, fileType, fileInfo) {
        const lastModified = fileInfo.mtime.toUTCString();
        const eTagValue = etag__WEBPACK_IMPORTED_MODULE_5__(fileInfo, {
            weak: this.requestHandler.config.eTag.type === _enums__WEBPACK_IMPORTED_MODULE_0__.ETAG_TYPE.Weak
        });
        const response = this.requestHandler.response;
        if (this.isClientHasFreshFile(lastModified, eTagValue)) { // client has fresh file
            response.statusCode = _enums__WEBPACK_IMPORTED_MODULE_0__.HTTP_STATUS_CODE.NotModified;
            response.end();
        }
        else {
            response.setHeader('Etag', eTagValue);
            response.setHeader('Last-Modified', lastModified);
            this.sendFileAsResponse(filePath, (0,_helpers__WEBPACK_IMPORTED_MODULE_4__.getMimeTypeFromFileType)(fileType));
        }
    }
}


/***/ }),

/***/ "./src/handlers/index.ts":
/*!*******************************!*\
  !*** ./src/handlers/index.ts ***!
  \*******************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   FileHandler: () => (/* reexport safe */ _file_handler__WEBPACK_IMPORTED_MODULE_2__.FileHandler),
/* harmony export */   InjectorHandler: () => (/* reexport safe */ _injector_handler__WEBPACK_IMPORTED_MODULE_4__.InjectorHandler),
/* harmony export */   RequestHandler: () => (/* reexport safe */ _request_handler__WEBPACK_IMPORTED_MODULE_1__.RequestHandler),
/* harmony export */   RequestHandlerHelper: () => (/* reexport safe */ _request_handler_helper__WEBPACK_IMPORTED_MODULE_3__.RequestHandlerHelper),
/* harmony export */   RouteHandler: () => (/* reexport safe */ _route_handler__WEBPACK_IMPORTED_MODULE_0__.RouteHandler)
/* harmony export */ });
/* harmony import */ var _route_handler__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ./route_handler */ "./src/handlers/route_handler.ts");
/* harmony import */ var _request_handler__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ./request_handler */ "./src/handlers/request_handler.ts");
/* harmony import */ var _file_handler__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! ./file_handler */ "./src/handlers/file_handler.ts");
/* harmony import */ var _request_handler_helper__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! ./request_handler_helper */ "./src/handlers/request_handler_helper.ts");
/* harmony import */ var _injector_handler__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! ./injector_handler */ "./src/handlers/injector_handler.ts");







/***/ }),

/***/ "./src/handlers/injector_handler.ts":
/*!******************************************!*\
  !*** ./src/handlers/injector_handler.ts ***!
  \******************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   InjectorHandler: () => (/* binding */ InjectorHandler)
/* harmony export */ });
/* harmony import */ var _constants__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ../constants */ "./src/constants/index.ts");

// this stores information of injector values that are available per class & worker
// const injectorStoreInfos: InjectorStoreInfo[] = [];
const injectorStoreInfos = new Map();
// this stores injector values
const injectorValues = [];
// this stores the singletons name & their respective index in injector values
const singletons = new Map();
class InjectorHandler {
    static addWorkerValue(className, methodName, paramIndex, paramValue, shouldFindIndex = true) {
        if (shouldFindIndex === true) {
            const paramValueIndex = injectorValues.indexOf(paramValue);
            if (paramValueIndex < 0) {
                paramValue = injectorValues.push(paramValue) - 1;
            }
            else {
                paramValue = paramValueIndex;
            }
        }
        const savedValue = injectorStoreInfos.get(className);
        if (savedValue == null) {
            const methods = [];
            methods[paramIndex] = paramValue;
            const value = new Map();
            value.set(methodName, methods);
            injectorStoreInfos.set(className, value);
        }
        else {
            let savedMethod = savedValue.get(methodName);
            if (savedMethod == null) {
                savedMethod = [];
                savedValue.set(methodName, savedMethod);
            }
            savedMethod[paramIndex] = paramValue;
        }
        return paramValue;
    }
    static getConstructorValues(className) {
        return this.getMethodValues(className, _constants__WEBPACK_IMPORTED_MODULE_0__.CONSTRUCTOR, null);
    }
    static getMethodValues(className, methodName, component) {
        const savedValue = injectorStoreInfos.get(className);
        if (savedValue != null) {
            const methodArgs = savedValue.get(methodName);
            if (methodArgs != null) {
                return methodArgs.map(injectorValueIndex => {
                    const value = injectorValues[injectorValueIndex];
                    switch (value['__fortReqType__']) {
                        case "body":
                        case "query":
                        case "param":
                            return value.inject(component);
                    }
                    return value;
                });
            }
        }
        return [];
    }
    static addSingleton(className, methodName, paramIndex, paramValue) {
        const singletonClassName = paramValue.name;
        if (singletonClassName) {
            const singletonValueStored = singletons.get(singletonClassName);
            if (singletonValueStored == null) {
                singletons.set(singletonClassName, InjectorHandler.addWorkerValue(className, methodName, paramIndex, new paramValue()));
            }
            else {
                InjectorHandler.addWorkerValue(className, methodName, paramIndex, singletonValueStored, false);
            }
        }
    }
}


/***/ }),

/***/ "./src/handlers/request_handler.ts":
/*!*****************************************!*\
  !*** ./src/handlers/request_handler.ts ***!
  \*****************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   RequestHandler: () => (/* binding */ RequestHandler)
/* harmony export */ });
/* harmony import */ var url__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! url */ "url");
/* harmony import */ var url__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(url__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _helpers__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ../helpers */ "./src/helpers/index.ts");
/* harmony import */ var _enums__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! ../enums */ "./src/enums/index.ts");
/* harmony import */ var _injector_handler__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! ./injector_handler */ "./src/handlers/injector_handler.ts");
/* harmony import */ var _file_handler__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! ./file_handler */ "./src/handlers/file_handler.ts");
/* harmony import */ var _request_handler_helper__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(/*! ./request_handler_helper */ "./src/handlers/request_handler_helper.ts");






class RequestHandler extends _request_handler_helper__WEBPACK_IMPORTED_MODULE_5__.RequestHandlerHelper {
    constructor() {
        super(...arguments);
        this.wallInstances = [];
    }
    registerEvents_() {
        this.request.on('error', (err) => {
            this.onBadRequest(err).catch(ex => {
                this.onErrorOccured(ex);
            });
        });
        this.response.on('error', this.onErrorOccured.bind(this));
    }
    executeWallIncoming_() {
        const walls = this.config.walls;
        const wallLength = walls.length;
        if (wallLength === 0)
            return;
        return (0,_helpers__WEBPACK_IMPORTED_MODULE_1__.promise)((res, rej) => {
            let index = 0;
            const executeWallIncomingByIndex = () => {
                if (wallLength > index) {
                    const wall = walls[index++];
                    const constructorArgsValues = _injector_handler__WEBPACK_IMPORTED_MODULE_3__.InjectorHandler.getConstructorValues(wall.name);
                    const wallObj = new wall(...constructorArgsValues);
                    wallObj['componentProp_'] = this.componentProps;
                    this.wallInstances.push(wallObj);
                    const methodArgsValues = _injector_handler__WEBPACK_IMPORTED_MODULE_3__.InjectorHandler.getMethodValues(wall.name, 'onIncoming', wallObj);
                    wallObj.onIncoming(...methodArgsValues).then(result => {
                        result == null ? executeWallIncomingByIndex() : res(result);
                    }).catch(rej);
                }
                else {
                    res(null);
                }
            };
            executeWallIncomingByIndex();
        });
    }
    async runController_() {
        const result = await this.executeController();
        return this.onResultFromComponent(result);
    }
    executeShieldsProtection_() {
        const shields = this.routeMatchInfo_.shields;
        const shieldLength = shields.length;
        if (shieldLength === 0)
            return;
        return (0,_helpers__WEBPACK_IMPORTED_MODULE_1__.promise)((res, rej) => {
            let index = 0;
            const executeShieldByIndex = () => {
                if (shieldLength > index) {
                    const shield = shields[index++];
                    const constructorArgsValues = _injector_handler__WEBPACK_IMPORTED_MODULE_3__.InjectorHandler.getConstructorValues(shield.name);
                    const shieldObj = new shield(...constructorArgsValues);
                    shieldObj['componentProp_'] = this.componentProps;
                    const methodArgsValues = _injector_handler__WEBPACK_IMPORTED_MODULE_3__.InjectorHandler.getMethodValues(shield.name, 'protect', shieldObj);
                    return shieldObj.protect(...methodArgsValues).then(result => {
                        result == null ? executeShieldByIndex() : res(this.onResultFromComponent(result));
                    }).catch(rej);
                }
                else {
                    res(null);
                }
            };
            executeShieldByIndex();
        });
    }
    executeGuardsCheck_(guards) {
        const guardLength = guards.length;
        if (guardLength === 0)
            return;
        return (0,_helpers__WEBPACK_IMPORTED_MODULE_1__.promise)((res, rej) => {
            let index = 0;
            const executeGuardByIndex = () => {
                if (guardLength > index) {
                    const guard = guards[index++];
                    const constructorArgsValues = _injector_handler__WEBPACK_IMPORTED_MODULE_3__.InjectorHandler.getConstructorValues(guard.name);
                    const guardObj = new guard(...constructorArgsValues);
                    guardObj['componentProp_'] = this.componentProps;
                    const methodArgsValues = _injector_handler__WEBPACK_IMPORTED_MODULE_3__.InjectorHandler.getMethodValues(guard.name, 'check', guardObj);
                    guardObj.check(...methodArgsValues).then(result => {
                        result == null ? executeGuardByIndex() : res(this.onResultFromComponent(result));
                    }).catch(rej);
                }
                else {
                    res(null);
                }
            };
            executeGuardByIndex();
        });
    }
    setPreHeader_() {
        const response = this.response;
        response.setHeader('X-Powered-By', this.config.appName);
        response.setHeader('Vary', 'Accept-Encoding');
        response.sendDate = true;
    }
    async onRouteMatched_() {
        const routeMatchInfo = this.routeMatchInfo_;
        const workerInfo = routeMatchInfo.workerInfo;
        if (workerInfo == null) {
            return () => {
                return this.request.method === _enums__WEBPACK_IMPORTED_MODULE_2__.HTTP_METHOD.Options ?
                    this.onRequestOptions(routeMatchInfo.allowedHttpMethod) :
                    this.onMethodNotAllowed(routeMatchInfo.allowedHttpMethod);
            };
        }
        const componentProps = this.componentProps;
        componentProps.param = routeMatchInfo.params;
        componentProps.controllerName = routeMatchInfo.controllerName;
        componentProps.workerInfo = workerInfo;
        const shieldResult = await this.executeShieldsProtection_();
        if (shieldResult)
            return shieldResult;
        const guardResult = await this.executeGuardsCheck_(workerInfo.guards);
        if (guardResult)
            return guardResult;
        return this.runController_();
    }
    runWallOutgoing_() {
        // check if only Cookie wall has been injected
        if (this.wallInstances.length === 0) {
            return;
        }
        const outgoingResults = [];
        (0,_helpers__WEBPACK_IMPORTED_MODULE_1__.reverseLoop)(this.wallInstances, (wallInstance) => {
            const methodArgsValues = _injector_handler__WEBPACK_IMPORTED_MODULE_3__.InjectorHandler.getMethodValues(wallInstance.constructor.name, 'onOutgoing', wallInstance);
            methodArgsValues.shift();
            outgoingResults.push(wallInstance.onOutgoing(this.controllerResult, ...methodArgsValues));
        });
        return Promise.all(outgoingResults);
    }
    async execute_() {
        const request = this.componentProps.request;
        const urlDetail = url__WEBPACK_IMPORTED_MODULE_0__.parse(request.url, true);
        this.componentProps.query = urlDetail.query;
        try {
            const wallResult = await this.executeWallIncoming_();
            if (wallResult) {
                this.controllerResult = wallResult;
                return this.handleFinalResult_();
            }
            const pathUrl = urlDetail.pathname;
            this.routeMatchInfo_ = (0,_helpers__WEBPACK_IMPORTED_MODULE_1__.parseAndMatchRoute)(pathUrl, request.method);
            const finalCallback = await (this.routeMatchInfo_ == null ? () => {
                const fileHandler = new _file_handler__WEBPACK_IMPORTED_MODULE_4__.FileHandler(this);
                return fileHandler.handleFileRequest(pathUrl);
            } :
                this.onRouteMatched_());
            await this.runWallOutgoing_();
            // using call to pass context, as methods are being returned mostly
            await finalCallback.call(this);
        }
        catch (ex) {
            this.onErrorOccured(ex);
        }
    }
    handle(request, response) {
        this.componentProps = {
            request,
            response,
            data: {},
            global: this.config
        };
        this.registerEvents_();
        this.setPreHeader_();
        this.execute_();
    }
    executeController() {
        const controller = this.routeMatchInfo_.controller;
        const controllerName = controller.name;
        const constructorValues = _injector_handler__WEBPACK_IMPORTED_MODULE_3__.InjectorHandler.getConstructorValues(controllerName);
        const controllerObj = new controller(...constructorValues);
        controllerObj['componentProp_'] = this.componentProps;
        const workerName = this.routeMatchInfo_.workerInfo.workerName;
        const methodArgsValues = _injector_handler__WEBPACK_IMPORTED_MODULE_3__.InjectorHandler.getMethodValues(controllerName, workerName, controllerObj);
        return controllerObj[workerName](...methodArgsValues);
    }
    onResultFromComponent(result) {
        this.controllerResult = result || (0,_helpers__WEBPACK_IMPORTED_MODULE_1__.textResult)("");
        // return () => {
        return this.handleFinalResult_;
        // }
    }
}


/***/ }),

/***/ "./src/handlers/request_handler_helper.ts":
/*!************************************************!*\
  !*** ./src/handlers/request_handler_helper.ts ***!
  \************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   RequestHandlerHelper: () => (/* binding */ RequestHandlerHelper)
/* harmony export */ });
/* harmony import */ var _enums__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ../enums */ "./src/enums/index.ts");
/* harmony import */ var _constants__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ../constants */ "./src/constants/index.ts");
/* harmony import */ var negotiator__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! negotiator */ "negotiator");
/* harmony import */ var negotiator__WEBPACK_IMPORTED_MODULE_2___default = /*#__PURE__*/__webpack_require__.n(negotiator__WEBPACK_IMPORTED_MODULE_2__);
/* harmony import */ var _helpers__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! ../helpers */ "./src/helpers/index.ts");
/* harmony import */ var path__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! path */ "path");
/* harmony import */ var path__WEBPACK_IMPORTED_MODULE_4___default = /*#__PURE__*/__webpack_require__.n(path__WEBPACK_IMPORTED_MODULE_4__);
/* harmony import */ var _file_handler__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(/*! ./file_handler */ "./src/handlers/file_handler.ts");






class RequestHandlerHelper {
    get request() {
        return this.componentProps.request;
    }
    get response() {
        return this.componentProps.response;
    }
    constructor(config) {
        this.config = config;
    }
    getContentTypeFromNegotiation(type) {
        return this.getContentTypeFromNegotiationHavingMultipleTypes((0,_helpers__WEBPACK_IMPORTED_MODULE_3__.getAvailableMimeTypes)(type) || [type]);
    }
    getContentTypeFromNegotiationHavingMultipleTypes(types) {
        const negotiator = new negotiator__WEBPACK_IMPORTED_MODULE_2__(this.request);
        return negotiator.mediaType(types);
    }
    onBadRequest(error) {
        return new this.config.errorHandler().onBadRequest(error).then(data => {
            return this.onResultFromError_(data);
        });
    }
    onForbiddenRequest() {
        return new this.config.errorHandler().onForbiddenRequest().then(data => {
            return this.onResultFromError_(data);
        });
    }
    onNotAcceptableRequest() {
        return new this.config.errorHandler().onNotAcceptableRequest().then(data => {
            return this.onResultFromError_(data);
        });
    }
    onNotFound() {
        return new this.config.errorHandler().onNotFound(this.request.url).then(data => {
            return this.onResultFromError_(data);
        });
    }
    onMethodNotAllowed(allowedMethods) {
        return new this.config.errorHandler().onMethodNotAllowed().then(data => {
            this.response.setHeader("Allow", allowedMethods.join(","));
            return this.onResultFromError_(data);
        });
    }
    // it won't execute wallOutgoing as if there is some issue in wallOutgoing
    // then it would become an infinite loop
    // treat it as someone comes to your fort & they start doing things 
    // which was not supposed to be done
    // then you don't follow regular rules but just throw them from anywhere
    onErrorOccured(error) {
        if (typeof error === 'string') {
            error = {
                message: error
            };
        }
        return new this.config.errorHandler().onServerError(error).then(data => {
            this.controllerResult = data;
            return this.returnResultFromError_();
        }).catch(ex => {
            const response = {
                message: ex.message,
                stack: ex.stack,
                type: ex.type
            };
            this.controllerResult = JSON.stringify(response);
            return this.returnResultFromError_();
        });
    }
    onRequestOptions(allowedMethods) {
        this.response.setHeader("Allow", allowedMethods.join(","));
        return this.onResultFromError_((0,_helpers__WEBPACK_IMPORTED_MODULE_3__.textResult)(""));
    }
    onResultFromError_(result) {
        this.controllerResult = result;
        this.returnResultFromError_();
    }
    setCookie() {
        if (this.config.shouldParseCookie === false)
            return;
        (this.componentProps.cookie['responseCookie_']).forEach(value => {
            this.response.setHeader(_constants__WEBPACK_IMPORTED_MODULE_1__.SET_COOKIE, value);
        });
    }
    returnResultFromError_() {
        const result = this.controllerResult;
        this.setCookie();
        switch (result.type) {
            case _enums__WEBPACK_IMPORTED_MODULE_0__.HTTP_RESULT_TYPE.Default:
                {
                    const contentType = result.contentType || _enums__WEBPACK_IMPORTED_MODULE_0__.MIME_TYPE.Text;
                    const negotiateMimeType = this.getContentTypeFromNegotiation(contentType);
                    this.endResponse_(negotiateMimeType != null ? negotiateMimeType : contentType);
                }
                break;
            case _enums__WEBPACK_IMPORTED_MODULE_0__.HTTP_RESULT_TYPE.FormattedResult:
                return this.handleFormatResult_();
        }
    }
    handleFormatResult_(shouldSendFirstMatch = false) {
        const controllerResult = this.controllerResult;
        const responseData = controllerResult.responseData;
        const negotiateMimeType = this.getContentTypeFromNegotiationHavingMultipleTypes(Object.keys(responseData));
        let key = Object.keys(responseData).find(qry => qry === negotiateMimeType);
        if (key != null) {
            controllerResult.responseData = responseData[key]();
            this.endResponse_(negotiateMimeType);
        }
        else if (shouldSendFirstMatch === true) {
            key = Object.keys(responseData)[0];
            controllerResult.responseData = responseData[key]();
            this.endResponse_(negotiateMimeType);
        }
        else {
            return this.onNotAcceptableRequest();
        }
    }
    endResponse_(negotiateMimeType) {
        const data = (0,_helpers__WEBPACK_IMPORTED_MODULE_3__.getResultBasedOnMiMe)(negotiateMimeType, (this.controllerResult).responseData, (type) => {
            negotiateMimeType = type;
        });
        if (this.response.headersSent) {
            console.trace("Request is finished, but triggered again");
            return;
        }
        this.response.writeHead(this.controllerResult.statusCode || _enums__WEBPACK_IMPORTED_MODULE_0__.HTTP_STATUS_CODE.Ok, { [_constants__WEBPACK_IMPORTED_MODULE_1__.CONTENT_TYPE]: negotiateMimeType });
        this.response.end(data);
    }
    handleRedirectResult_() {
        this.response.writeHead(this.controllerResult.statusCode || _enums__WEBPACK_IMPORTED_MODULE_0__.HTTP_STATUS_CODE.Ok, { 'Location': this.controllerResult.responseData });
        this.response.end();
        return null;
    }
    handleFileResult_() {
        const result = this.controllerResult;
        const fileResult = result.responseData;
        const parsedPath = (0,path__WEBPACK_IMPORTED_MODULE_4__.parse)(fileResult.filePath);
        if (fileResult.shouldDownload === true) {
            const fileName = fileResult.alias == null ? parsedPath.name : fileResult.alias;
            this.response.setHeader("content-disposition", `attachment;filename=${fileName}${parsedPath.ext}`);
        }
        const fileHandler = new _file_handler__WEBPACK_IMPORTED_MODULE_5__.FileHandler(this);
        return fileHandler.handleFileRequestFromAbsolutePath(fileResult.filePath, parsedPath.ext);
    }
    handleFinalResult_() {
        const result = this.controllerResult;
        this.setCookie();
        switch (result.type) {
            case _enums__WEBPACK_IMPORTED_MODULE_0__.HTTP_RESULT_TYPE.Default:
                {
                    const contentType = result.contentType || _enums__WEBPACK_IMPORTED_MODULE_0__.MIME_TYPE.Text;
                    const negotiateMimeType = this.getContentTypeFromNegotiation(contentType);
                    if (negotiateMimeType != null) {
                        this.endResponse_(negotiateMimeType);
                    }
                    else {
                        return this.onNotAcceptableRequest();
                    }
                }
                break;
            case _enums__WEBPACK_IMPORTED_MODULE_0__.HTTP_RESULT_TYPE.Redirect:
                return this.handleRedirectResult_();
            case _enums__WEBPACK_IMPORTED_MODULE_0__.HTTP_RESULT_TYPE.File:
                return this.handleFileResult_();
            case _enums__WEBPACK_IMPORTED_MODULE_0__.HTTP_RESULT_TYPE.FormattedResult:
                return this.handleFormatResult_();
        }
    }
}


/***/ }),

/***/ "./src/handlers/route_handler.ts":
/*!***************************************!*\
  !*** ./src/handlers/route_handler.ts ***!
  \***************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   RouteHandler: () => (/* binding */ RouteHandler)
/* harmony export */ });
/* harmony import */ var _utils__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ../utils */ "./src/utils/index.ts");
/* harmony import */ var _models__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ../models */ "./src/models/index.ts");
/* harmony import */ var _helpers__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! ../helpers */ "./src/helpers/index.ts");



const routerCollection = new Map();
const pushRouterIntoCollection = (route) => {
    const routeObj = new _models__WEBPACK_IMPORTED_MODULE_1__.RouteInfo(route);
    routerCollection.set(route.controllerName, routeObj);
};
const getWorkerPattern = (controllerPath, pattern) => {
    const routeWithParent = ((0,_utils__WEBPACK_IMPORTED_MODULE_0__.isNull)(controllerPath) || controllerPath === "/*") ? pattern : `${controllerPath}${pattern}`;
    return routeWithParent;
};
const routeCache = new Map();
function isControllerMatched(controller, urlParts) {
    let isMatched;
    const patternSplit = controller.pathSplitted;
    patternSplit.every((patternPart, i) => {
        isMatched = (0,_utils__WEBPACK_IMPORTED_MODULE_0__.compareString)(urlParts[i], patternPart);
        return isMatched;
    });
    return isMatched;
}
function findControllerChildren(urlParts, parentController) {
    const childRoutes = parentController.partialRoutes;
    if (!childRoutes)
        return;
    urlParts = urlParts.slice(parentController.pathSplitted.length);
    for (const index in childRoutes) {
        const d = childRoutes[index];
        const controller = RouteHandler.getControllerFromName(d.controllerName);
        const isMatched = isControllerMatched(controller, urlParts);
        if (isMatched === true) {
            const childController = findControllerChildren(urlParts, controller);
            return childController || controller;
        }
    }
}
function getPartialRoutes(route, parentRoute) {
    return route.children && route.children.map(child => {
        const controllerName = child.controller.name;
        const savedRoute = routerCollection.get(controllerName);
        savedRoute.path = child.path;
        const controllerRoutePath = `${route.path}/${child.path}`;
        child.path = controllerRoutePath;
        savedRoute.workers.forEach(worker => {
            worker.pattern = getWorkerPattern(controllerRoutePath, worker.pattern);
        });
        savedRoute.shields.unshift(...parentRoute.shields);
        savedRoute.controller = child.controller;
        savedRoute.partialRoutes = getPartialRoutes(child, savedRoute);
        return {
            controllerName: controllerName,
            path: child.path
        };
    });
}
class RouteHandler {
    static get routerCollection() {
        return routerCollection;
    }
    static get routesAsArray() {
        return Array.from(routerCollection.keys()).map(workerName => {
            return routerCollection.get(workerName);
        });
    }
    static findControllerFromPath(urlParts) {
        for (const controller of routerCollection.values()) {
            const isMatched = isControllerMatched(controller, urlParts);
            if (isMatched === true) {
                const childController = findControllerChildren(urlParts, controller);
                return childController || controller;
            }
        }
    }
    static getControllerFromName(name) {
        return routerCollection.get(name);
    }
    static get defaultRoute() {
        return routerCollection.get(RouteHandler.defaultRouteControllerName);
    }
    static addToRouterCollection(inputRoute) {
        const route = routerCollection.get(inputRoute.controller.name);
        const partialRoutes = getPartialRoutes(inputRoute, route);
        if (route == null) {
            pushRouterIntoCollection({
                workers: new Map(),
                controller: inputRoute.controller,
                controllerName: inputRoute.controller.name,
                path: inputRoute.path,
                shields: [],
                values: [],
                partialRoutes: partialRoutes
            });
        }
        else {
            route.controller = inputRoute.controller;
            route.path = inputRoute.path;
            route.partialRoutes = partialRoutes;
            // change pattern value since we have controller name now.
            route.workers.forEach(worker => {
                worker.pattern = getWorkerPattern(inputRoute.path, worker.pattern);
            });
        }
    }
    static addShields(shields, className) {
        const route = routerCollection.get(className);
        if (route == null) {
            pushRouterIntoCollection({
                workers: new Map(),
                controller: null,
                controllerName: className,
                shields: shields,
                path: null,
                values: []
            });
        }
        else {
            route.shields = route.shields ? [...route.shields, ...shields] : shields;
        }
    }
    static addWorker(newWorker, className) {
        const workerName = newWorker.workerName;
        const route = routerCollection.get(className);
        if (route == null) {
            pushRouterIntoCollection({
                workers: new Map([
                    [workerName, new _models__WEBPACK_IMPORTED_MODULE_1__.WorkerInfo(newWorker)]
                ]),
                controller: null,
                controllerName: className,
                shields: [],
                path: null,
                values: []
            });
        }
        else {
            const savedAction = route.workers.get(workerName);
            if (savedAction == null) {
                newWorker.pattern = getWorkerPattern(route.path, newWorker.pattern);
                route.workers.set(workerName, new _models__WEBPACK_IMPORTED_MODULE_1__.WorkerInfo(newWorker));
            }
            else {
                savedAction.methodsAllowed = newWorker.methodsAllowed;
                savedAction.pattern = getWorkerPattern(route.path, savedAction.pattern);
                // route.path == null ? savedAction.pattern : `/${route.path}${savedAction.pattern}`;
            }
        }
    }
    static addGuards(guards, className, workerName) {
        const route = routerCollection.get(className);
        const pattern = workerName.toLowerCase();
        if (route == null) {
            pushRouterIntoCollection({
                workers: new Map([
                    [workerName, new _models__WEBPACK_IMPORTED_MODULE_1__.WorkerInfo({
                            workerName: workerName,
                            guards: guards,
                            methodsAllowed: null,
                            pattern: pattern,
                            values: []
                        })]
                ]),
                controller: null,
                controllerName: className,
                shields: [],
                path: null,
                values: []
            });
        }
        else {
            const savedAction = route.workers.get(workerName);
            if (savedAction == null) {
                route.workers.set(workerName, new _models__WEBPACK_IMPORTED_MODULE_1__.WorkerInfo({
                    workerName: workerName,
                    guards: guards,
                    methodsAllowed: null,
                    pattern: pattern,
                    values: []
                }));
            }
            else {
                savedAction.guards = savedAction.guards ? [...savedAction.guards, ...guards]
                    : guards;
            }
        }
    }
    static addPattern(pattern, className, workerName) {
        const route = routerCollection.get(className);
        if (route == null) {
            pushRouterIntoCollection({
                workers: new Map([
                    [workerName, new _models__WEBPACK_IMPORTED_MODULE_1__.WorkerInfo({
                            workerName: workerName,
                            guards: [],
                            methodsAllowed: null,
                            pattern: pattern,
                            values: []
                        })]
                ]),
                controller: null,
                controllerName: className,
                shields: [],
                path: null,
                values: []
            });
        }
        else {
            const savedAction = route.workers.get(workerName);
            const workerRouteWithController = getWorkerPattern(route.path, pattern);
            if (savedAction == null) {
                route.workers.set(workerName, new _models__WEBPACK_IMPORTED_MODULE_1__.WorkerInfo({
                    workerName: workerName,
                    guards: [],
                    methodsAllowed: null,
                    pattern: workerRouteWithController,
                    values: []
                }));
            }
            else {
                savedAction.pattern = workerRouteWithController;
            }
        }
    }
    static addExpected(type, className, workerName, expectedValue) {
        for (const prop in expectedValue) {
            const propValue = expectedValue[prop];
            expectedValue[prop] = (0,_helpers__WEBPACK_IMPORTED_MODULE_2__.getDataType)(propValue);
        }
        const pattern = workerName.toLowerCase();
        const router = routerCollection.get(className);
        const worker = new _models__WEBPACK_IMPORTED_MODULE_1__.WorkerInfo({
            workerName: workerName,
            guards: [],
            methodsAllowed: null,
            pattern: pattern,
            values: []
        });
        switch (type) {
            case "body":
                worker.expectedBody = expectedValue;
                break;
            case "query":
                worker.expectedQuery = expectedValue;
                break;
            case "param":
                worker.expectedParam = expectedValue;
                break;
        }
        if (router == null) {
            pushRouterIntoCollection({
                workers: new Map([
                    [workerName, worker]
                ]),
                controller: null,
                controllerName: className,
                shields: [],
                path: null,
                values: []
            });
        }
        else {
            const savedAction = router.workers.get(workerName);
            if (savedAction == null) {
                router.workers.set(workerName, worker);
            }
            else {
                savedAction.expectedQuery = worker.expectedQuery;
                savedAction.expectedBody = worker.expectedBody;
                savedAction.expectedParam = worker.expectedParam;
            }
        }
    }
    static addCache(cacheOption, className, workerName) {
        const route = routerCollection.get(className);
        const pattern = workerName.toLowerCase();
        if (route == null) {
            pushRouterIntoCollection({
                workers: new Map([
                    [workerName, new _models__WEBPACK_IMPORTED_MODULE_1__.WorkerInfo({
                            workerName: workerName,
                            guards: [],
                            methodsAllowed: null,
                            pattern: pattern,
                            values: [],
                            cache: cacheOption
                        })]
                ]),
                controller: null,
                controllerName: className,
                shields: [],
                path: null,
                values: []
            });
        }
        else {
            const savedAction = route.workers.get(workerName);
            if (savedAction == null) {
                route.workers.set(workerName, new _models__WEBPACK_IMPORTED_MODULE_1__.WorkerInfo({
                    workerName: workerName,
                    guards: [],
                    methodsAllowed: null,
                    pattern: pattern,
                    values: [],
                    cache: cacheOption
                }));
            }
            else {
                savedAction.cache = cacheOption;
            }
        }
    }
    static addRouteToCache(url, route) {
        routeCache.set(url, route);
    }
    static getRouteFromCache(url) {
        return routeCache.get(url);
    }
}


/***/ }),

/***/ "./src/helpers/download_result.ts":
/*!****************************************!*\
  !*** ./src/helpers/download_result.ts ***!
  \****************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   downloadResult: () => (/* binding */ downloadResult)
/* harmony export */ });
/* harmony import */ var _enums__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ../enums */ "./src/enums/index.ts");
/* harmony import */ var _enums_http_status_code__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ../enums/http_status_code */ "./src/enums/http_status_code.ts");


const downloadResult = (filePath, downloadFileName) => {
    return {
        statusCode: _enums_http_status_code__WEBPACK_IMPORTED_MODULE_1__.HTTP_STATUS_CODE.Ok,
        responseData: {
            filePath: filePath,
            shouldDownload: true,
            alias: downloadFileName
        },
        type: _enums__WEBPACK_IMPORTED_MODULE_0__.HTTP_RESULT_TYPE.File
    };
};


/***/ }),

/***/ "./src/helpers/execute_validate.ts":
/*!*****************************************!*\
  !*** ./src/helpers/execute_validate.ts ***!
  \*****************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   executeValidate: () => (/* binding */ executeValidate)
/* harmony export */ });
const executeValidate = async (validator, dtoClass, data) => {
    const dtoInstance = new dtoClass(data);
    if (Object.keys(dtoInstance).length === 0) {
        Object.assign(dtoInstance, data);
    }
    const validationResult = await validator.validate(dtoInstance);
    if (validationResult) {
        return {
            error: validator.getErrorResult(validationResult)
        };
    }
    return {
        model: dtoInstance
    };
};


/***/ }),

/***/ "./src/helpers/file_result.ts":
/*!************************************!*\
  !*** ./src/helpers/file_result.ts ***!
  \************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   fileResult: () => (/* binding */ fileResult)
/* harmony export */ });
/* harmony import */ var _enums__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ../enums */ "./src/enums/index.ts");

const fileResult = (filePath) => {
    return {
        statusCode: _enums__WEBPACK_IMPORTED_MODULE_0__.HTTP_STATUS_CODE.Ok,
        responseData: {
            filePath: filePath
        },
        type: _enums__WEBPACK_IMPORTED_MODULE_0__.HTTP_RESULT_TYPE.File
    };
};


/***/ }),

/***/ "./src/helpers/get_available_mime_type.ts":
/*!************************************************!*\
  !*** ./src/helpers/get_available_mime_type.ts ***!
  \************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   getAvailableMimeTypes: () => (/* binding */ getAvailableMimeTypes)
/* harmony export */ });
/* harmony import */ var _enums__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ../enums */ "./src/enums/index.ts");

const jsonMimeType = [_enums__WEBPACK_IMPORTED_MODULE_0__.MIME_TYPE.Json, _enums__WEBPACK_IMPORTED_MODULE_0__.MIME_TYPE.Xml];
const textMimeType = [_enums__WEBPACK_IMPORTED_MODULE_0__.MIME_TYPE.Text, _enums__WEBPACK_IMPORTED_MODULE_0__.MIME_TYPE.Html, _enums__WEBPACK_IMPORTED_MODULE_0__.MIME_TYPE.Js,
    _enums__WEBPACK_IMPORTED_MODULE_0__.MIME_TYPE.Css, _enums__WEBPACK_IMPORTED_MODULE_0__.MIME_TYPE.Rtf, _enums__WEBPACK_IMPORTED_MODULE_0__.MIME_TYPE.Csv];
const getAvailableMimeTypes = (type) => {
    switch (type) {
        case _enums__WEBPACK_IMPORTED_MODULE_0__.MIME_TYPE.Json:
        case _enums__WEBPACK_IMPORTED_MODULE_0__.MIME_TYPE.Xml:
            return jsonMimeType;
        case _enums__WEBPACK_IMPORTED_MODULE_0__.MIME_TYPE.Html:
        case _enums__WEBPACK_IMPORTED_MODULE_0__.MIME_TYPE.Css:
        case _enums__WEBPACK_IMPORTED_MODULE_0__.MIME_TYPE.Csv:
        case _enums__WEBPACK_IMPORTED_MODULE_0__.MIME_TYPE.Js:
        case _enums__WEBPACK_IMPORTED_MODULE_0__.MIME_TYPE.Rtf:
        case _enums__WEBPACK_IMPORTED_MODULE_0__.MIME_TYPE.Text:
            return textMimeType;
    }
};


/***/ }),

/***/ "./src/helpers/get_class_name.ts":
/*!***************************************!*\
  !*** ./src/helpers/get_class_name.ts ***!
  \***************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   getClassName: () => (/* binding */ getClassName)
/* harmony export */ });
const getClassName = (target) => {
    return target.name || (target.constructor && target.constructor.name);
};


/***/ }),

/***/ "./src/helpers/get_data_type.ts":
/*!**************************************!*\
  !*** ./src/helpers/get_data_type.ts ***!
  \**************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   getDataType: () => (/* binding */ getDataType)
/* harmony export */ });
/* harmony import */ var _enums_data_type__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ../enums/data_type */ "./src/enums/data_type.ts");

const getDataType = (value) => {
    const type = typeof value;
    switch (type) {
        case 'object':
            if (Array.isArray(value)) {
                return _enums_data_type__WEBPACK_IMPORTED_MODULE_0__.DATA_TYPE.Array;
            }
        default:
            return type;
    }
};


/***/ }),

/***/ "./src/helpers/get_mime_type_from_extension.ts":
/*!*****************************************************!*\
  !*** ./src/helpers/get_mime_type_from_extension.ts ***!
  \*****************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   getMimeTypeFromExtension: () => (/* binding */ getMimeTypeFromExtension)
/* harmony export */ });
/* harmony import */ var _enums__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ../enums */ "./src/enums/index.ts");

const getMimeTypeFromExtension = (ext) => {
    switch (ext) {
        case ".htm":
        case ".html":
            return _enums__WEBPACK_IMPORTED_MODULE_0__.MIME_TYPE.Html;
        case ".css":
            return _enums__WEBPACK_IMPORTED_MODULE_0__.MIME_TYPE.Css;
        case ".js":
            return _enums__WEBPACK_IMPORTED_MODULE_0__.MIME_TYPE.Js;
        case ".png":
            return _enums__WEBPACK_IMPORTED_MODULE_0__.MIME_TYPE.Png;
        case ".woff":
            return _enums__WEBPACK_IMPORTED_MODULE_0__.MIME_TYPE.Woff;
        case ".woff2":
            return _enums__WEBPACK_IMPORTED_MODULE_0__.MIME_TYPE.Woff2;
        case ".json":
            return _enums__WEBPACK_IMPORTED_MODULE_0__.MIME_TYPE.Json;
        case ".txt":
            return _enums__WEBPACK_IMPORTED_MODULE_0__.MIME_TYPE.Text;
        case ".jpg":
        case ".jpeg":
            return _enums__WEBPACK_IMPORTED_MODULE_0__.MIME_TYPE.Jpeg;
        case ".rtf":
            return _enums__WEBPACK_IMPORTED_MODULE_0__.MIME_TYPE.Rtf;
        case ".ttf":
            return _enums__WEBPACK_IMPORTED_MODULE_0__.MIME_TYPE.Ttf;
        case ".eot":
            return _enums__WEBPACK_IMPORTED_MODULE_0__.MIME_TYPE.Eot;
        case '.otf':
            return _enums__WEBPACK_IMPORTED_MODULE_0__.MIME_TYPE.Otf;
        case ".swf":
            return _enums__WEBPACK_IMPORTED_MODULE_0__.MIME_TYPE.Swf;
        case ".avi":
            return _enums__WEBPACK_IMPORTED_MODULE_0__.MIME_TYPE.Avi;
        case ".svg":
            return _enums__WEBPACK_IMPORTED_MODULE_0__.MIME_TYPE.Svg;
        case ".pdf":
            return _enums__WEBPACK_IMPORTED_MODULE_0__.MIME_TYPE.Pdf;
        case ".xml":
            return _enums__WEBPACK_IMPORTED_MODULE_0__.MIME_TYPE.Xml;
        case ".csv":
            return _enums__WEBPACK_IMPORTED_MODULE_0__.MIME_TYPE.Csv;
        case ".xls":
            return _enums__WEBPACK_IMPORTED_MODULE_0__.MIME_TYPE.Xls;
        case ".xlsx":
            return _enums__WEBPACK_IMPORTED_MODULE_0__.MIME_TYPE.Xlsx;
        case ".bmp":
            return _enums__WEBPACK_IMPORTED_MODULE_0__.MIME_TYPE.Bmp;
        case ".gif":
            return _enums__WEBPACK_IMPORTED_MODULE_0__.MIME_TYPE.Gif;
        default:
            return "application/octet-stream";
    }
};


/***/ }),

/***/ "./src/helpers/get_mime_type_from_file_type.ts":
/*!*****************************************************!*\
  !*** ./src/helpers/get_mime_type_from_file_type.ts ***!
  \*****************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   getMimeTypeFromFileType: () => (/* binding */ getMimeTypeFromFileType)
/* harmony export */ });
/* harmony import */ var _get_mime_type_from_extension__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ./get_mime_type_from_extension */ "./src/helpers/get_mime_type_from_extension.ts");

function getMimeTypeFromFileType(fileType) {
    return fileType[0] === '.' ? (0,_get_mime_type_from_extension__WEBPACK_IMPORTED_MODULE_0__.getMimeTypeFromExtension)(fileType) :
        fileType;
}


/***/ }),

/***/ "./src/helpers/get_result_based_on_mime.ts":
/*!*************************************************!*\
  !*** ./src/helpers/get_result_based_on_mime.ts ***!
  \*************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   getResultBasedOnMiMe: () => (/* binding */ getResultBasedOnMiMe),
/* harmony export */   setResultMapper: () => (/* binding */ setResultMapper)
/* harmony export */ });
/* harmony import */ var _enums__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ../enums */ "./src/enums/index.ts");

let getResultBasedOnMiMe = (type, result, setMimeType) => {
    switch (type) {
        case _enums__WEBPACK_IMPORTED_MODULE_0__.MIME_TYPE.Json:
        case _enums__WEBPACK_IMPORTED_MODULE_0__.MIME_TYPE.Text:
        case _enums__WEBPACK_IMPORTED_MODULE_0__.MIME_TYPE.Html:
        case _enums__WEBPACK_IMPORTED_MODULE_0__.MIME_TYPE.Xml:
            if (typeof result === 'object' === true) {
                setMimeType(_enums__WEBPACK_IMPORTED_MODULE_0__.MIME_TYPE.Json);
                return JSON.stringify(result);
            }
    }
    return result;
};
function setResultMapper(mapper) {
    getResultBasedOnMiMe = (type, result, callBack) => {
        return new mapper().map(type, result, callBack);
    };
}


/***/ }),

/***/ "./src/helpers/get_view_from_file.ts":
/*!*******************************************!*\
  !*** ./src/helpers/get_view_from_file.ts ***!
  \*******************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   getViewFromFile: () => (/* binding */ getViewFromFile)
/* harmony export */ });
/* harmony import */ var fs_extra__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! fs-extra */ "fs-extra");
/* harmony import */ var fs_extra__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(fs_extra__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var path__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! path */ "path");
/* harmony import */ var path__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(path__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var _utils__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! ../utils */ "./src/utils/index.ts");
/* harmony import */ var _models__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! ../models */ "./src/models/index.ts");




const viewCache = {};
let getViewFromFile;
const readView = (option) => {
    const pathOfView = path__WEBPACK_IMPORTED_MODULE_1__.join(_models__WEBPACK_IMPORTED_MODULE_3__.Fort.viewPath, option.fileLocation);
    // eslint-disable-next-line
    return (0,fs_extra__WEBPACK_IMPORTED_MODULE_0__.readFile)(pathOfView, {
        encoding: 'utf8'
    }).then(result => {
        if (option.mapView != null) {
            return option.mapView(result);
        }
        return result;
    });
};
if (false) {}
else {
    getViewFromFile = function (option) {
        return readView(option);
    };
}


/***/ }),

/***/ "./src/helpers/html_result.ts":
/*!************************************!*\
  !*** ./src/helpers/html_result.ts ***!
  \************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   htmlResult: () => (/* binding */ htmlResult)
/* harmony export */ });
/* harmony import */ var _enums__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ../enums */ "./src/enums/index.ts");
/* harmony import */ var _enums_http_status_code__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ../enums/http_status_code */ "./src/enums/http_status_code.ts");


const htmlResult = (html, statusCode) => {
    return {
        contentType: _enums__WEBPACK_IMPORTED_MODULE_0__.MIME_TYPE.Html,
        responseData: html,
        statusCode: statusCode || _enums_http_status_code__WEBPACK_IMPORTED_MODULE_1__.HTTP_STATUS_CODE.Ok,
        type: _enums__WEBPACK_IMPORTED_MODULE_0__.HTTP_RESULT_TYPE.Default
    };
};


/***/ }),

/***/ "./src/helpers/index.ts":
/*!******************************!*\
  !*** ./src/helpers/index.ts ***!
  \******************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   JsonHelper: () => (/* reexport safe */ _json_helper__WEBPACK_IMPORTED_MODULE_14__.JsonHelper),
/* harmony export */   LogHelper: () => (/* reexport safe */ _log_helper__WEBPACK_IMPORTED_MODULE_10__.LogHelper),
/* harmony export */   ValidateBodyGuard: () => (/* reexport safe */ _validate_body_guard__WEBPACK_IMPORTED_MODULE_25__.ValidateBodyGuard),
/* harmony export */   ValidateParamGuard: () => (/* reexport safe */ _validate_param_guard__WEBPACK_IMPORTED_MODULE_24__.ValidateParamGuard),
/* harmony export */   ValidateQueryShield: () => (/* reexport safe */ _validate_query_shield__WEBPACK_IMPORTED_MODULE_26__.ValidateQueryShield),
/* harmony export */   downloadResult: () => (/* reexport safe */ _download_result__WEBPACK_IMPORTED_MODULE_4__.downloadResult),
/* harmony export */   fileResult: () => (/* reexport safe */ _file_result__WEBPACK_IMPORTED_MODULE_5__.fileResult),
/* harmony export */   getAvailableMimeTypes: () => (/* reexport safe */ _get_available_mime_type__WEBPACK_IMPORTED_MODULE_29__.getAvailableMimeTypes),
/* harmony export */   getClassName: () => (/* reexport safe */ _get_class_name__WEBPACK_IMPORTED_MODULE_19__.getClassName),
/* harmony export */   getDataType: () => (/* reexport safe */ _get_data_type__WEBPACK_IMPORTED_MODULE_18__.getDataType),
/* harmony export */   getMimeTypeFromExtension: () => (/* reexport safe */ _get_mime_type_from_extension__WEBPACK_IMPORTED_MODULE_11__.getMimeTypeFromExtension),
/* harmony export */   getMimeTypeFromFileType: () => (/* reexport safe */ _get_mime_type_from_file_type__WEBPACK_IMPORTED_MODULE_22__.getMimeTypeFromFileType),
/* harmony export */   getResultBasedOnMiMe: () => (/* reexport safe */ _get_result_based_on_mime__WEBPACK_IMPORTED_MODULE_21__.getResultBasedOnMiMe),
/* harmony export */   getViewFromFile: () => (/* reexport safe */ _get_view_from_file__WEBPACK_IMPORTED_MODULE_8__.getViewFromFile),
/* harmony export */   htmlResult: () => (/* reexport safe */ _html_result__WEBPACK_IMPORTED_MODULE_2__.htmlResult),
/* harmony export */   initController: () => (/* reexport safe */ _test__WEBPACK_IMPORTED_MODULE_28__.initController),
/* harmony export */   initGuard: () => (/* reexport safe */ _test__WEBPACK_IMPORTED_MODULE_28__.initGuard),
/* harmony export */   initShield: () => (/* reexport safe */ _test__WEBPACK_IMPORTED_MODULE_28__.initShield),
/* harmony export */   initWall: () => (/* reexport safe */ _test__WEBPACK_IMPORTED_MODULE_28__.initWall),
/* harmony export */   joinRoute: () => (/* reexport safe */ _split_route__WEBPACK_IMPORTED_MODULE_23__.joinRoute),
/* harmony export */   jsonResult: () => (/* reexport safe */ _json_result__WEBPACK_IMPORTED_MODULE_0__.jsonResult),
/* harmony export */   multiFormatResult: () => (/* reexport safe */ _multi_format_result__WEBPACK_IMPORTED_MODULE_27__.multiFormatResult),
/* harmony export */   parseAndMatchRoute: () => (/* reexport safe */ _parse_match_route__WEBPACK_IMPORTED_MODULE_12__.parseAndMatchRoute),
/* harmony export */   parseCookie: () => (/* reexport safe */ _parse_cookie__WEBPACK_IMPORTED_MODULE_13__.parseCookie),
/* harmony export */   promise: () => (/* reexport safe */ _promise__WEBPACK_IMPORTED_MODULE_9__.promise),
/* harmony export */   redirectResult: () => (/* reexport safe */ _redirect_result__WEBPACK_IMPORTED_MODULE_6__.redirectResult),
/* harmony export */   removeFirstSlash: () => (/* reexport safe */ _remove_first_slash__WEBPACK_IMPORTED_MODULE_16__.removeFirstSlash),
/* harmony export */   removeLastSlash: () => (/* reexport safe */ _remove_last_slash__WEBPACK_IMPORTED_MODULE_15__.removeLastSlash),
/* harmony export */   removeMethodAndNullFromObject: () => (/* reexport safe */ _remove_method_and_null_from_object__WEBPACK_IMPORTED_MODULE_20__.removeMethodAndNullFromObject),
/* harmony export */   renderView: () => (/* reexport safe */ _render_view__WEBPACK_IMPORTED_MODULE_3__.renderView),
/* harmony export */   reverseLoop: () => (/* reexport safe */ _reverse_loop__WEBPACK_IMPORTED_MODULE_17__.reverseLoop),
/* harmony export */   setResultMapper: () => (/* reexport safe */ _get_result_based_on_mime__WEBPACK_IMPORTED_MODULE_21__.setResultMapper),
/* harmony export */   splitRoute: () => (/* reexport safe */ _split_route__WEBPACK_IMPORTED_MODULE_23__.splitRoute),
/* harmony export */   textResult: () => (/* reexport safe */ _text_result__WEBPACK_IMPORTED_MODULE_1__.textResult),
/* harmony export */   viewResult: () => (/* reexport safe */ _view_result__WEBPACK_IMPORTED_MODULE_7__.viewResult)
/* harmony export */ });
/* harmony import */ var _json_result__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ./json_result */ "./src/helpers/json_result.ts");
/* harmony import */ var _text_result__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ./text_result */ "./src/helpers/text_result.ts");
/* harmony import */ var _html_result__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! ./html_result */ "./src/helpers/html_result.ts");
/* harmony import */ var _render_view__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! ./render_view */ "./src/helpers/render_view.ts");
/* harmony import */ var _download_result__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! ./download_result */ "./src/helpers/download_result.ts");
/* harmony import */ var _file_result__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(/*! ./file_result */ "./src/helpers/file_result.ts");
/* harmony import */ var _redirect_result__WEBPACK_IMPORTED_MODULE_6__ = __webpack_require__(/*! ./redirect_result */ "./src/helpers/redirect_result.ts");
/* harmony import */ var _view_result__WEBPACK_IMPORTED_MODULE_7__ = __webpack_require__(/*! ./view_result */ "./src/helpers/view_result.ts");
/* harmony import */ var _get_view_from_file__WEBPACK_IMPORTED_MODULE_8__ = __webpack_require__(/*! ./get_view_from_file */ "./src/helpers/get_view_from_file.ts");
/* harmony import */ var _promise__WEBPACK_IMPORTED_MODULE_9__ = __webpack_require__(/*! ./promise */ "./src/helpers/promise.ts");
/* harmony import */ var _log_helper__WEBPACK_IMPORTED_MODULE_10__ = __webpack_require__(/*! ./log_helper */ "./src/helpers/log_helper.ts");
/* harmony import */ var _get_mime_type_from_extension__WEBPACK_IMPORTED_MODULE_11__ = __webpack_require__(/*! ./get_mime_type_from_extension */ "./src/helpers/get_mime_type_from_extension.ts");
/* harmony import */ var _parse_match_route__WEBPACK_IMPORTED_MODULE_12__ = __webpack_require__(/*! ./parse_match_route */ "./src/helpers/parse_match_route.ts");
/* harmony import */ var _parse_cookie__WEBPACK_IMPORTED_MODULE_13__ = __webpack_require__(/*! ./parse_cookie */ "./src/helpers/parse_cookie.ts");
/* harmony import */ var _json_helper__WEBPACK_IMPORTED_MODULE_14__ = __webpack_require__(/*! ./json_helper */ "./src/helpers/json_helper.ts");
/* harmony import */ var _remove_last_slash__WEBPACK_IMPORTED_MODULE_15__ = __webpack_require__(/*! ./remove_last_slash */ "./src/helpers/remove_last_slash.ts");
/* harmony import */ var _remove_first_slash__WEBPACK_IMPORTED_MODULE_16__ = __webpack_require__(/*! ./remove_first_slash */ "./src/helpers/remove_first_slash.ts");
/* harmony import */ var _reverse_loop__WEBPACK_IMPORTED_MODULE_17__ = __webpack_require__(/*! ./reverse_loop */ "./src/helpers/reverse_loop.ts");
/* harmony import */ var _get_data_type__WEBPACK_IMPORTED_MODULE_18__ = __webpack_require__(/*! ./get_data_type */ "./src/helpers/get_data_type.ts");
/* harmony import */ var _get_class_name__WEBPACK_IMPORTED_MODULE_19__ = __webpack_require__(/*! ./get_class_name */ "./src/helpers/get_class_name.ts");
/* harmony import */ var _remove_method_and_null_from_object__WEBPACK_IMPORTED_MODULE_20__ = __webpack_require__(/*! ./remove_method_and_null_from_object */ "./src/helpers/remove_method_and_null_from_object.ts");
/* harmony import */ var _get_result_based_on_mime__WEBPACK_IMPORTED_MODULE_21__ = __webpack_require__(/*! ./get_result_based_on_mime */ "./src/helpers/get_result_based_on_mime.ts");
/* harmony import */ var _get_mime_type_from_file_type__WEBPACK_IMPORTED_MODULE_22__ = __webpack_require__(/*! ./get_mime_type_from_file_type */ "./src/helpers/get_mime_type_from_file_type.ts");
/* harmony import */ var _split_route__WEBPACK_IMPORTED_MODULE_23__ = __webpack_require__(/*! ./split_route */ "./src/helpers/split_route.ts");
/* harmony import */ var _validate_param_guard__WEBPACK_IMPORTED_MODULE_24__ = __webpack_require__(/*! ./validate_param_guard */ "./src/helpers/validate_param_guard.ts");
/* harmony import */ var _validate_body_guard__WEBPACK_IMPORTED_MODULE_25__ = __webpack_require__(/*! ./validate_body_guard */ "./src/helpers/validate_body_guard.ts");
/* harmony import */ var _validate_query_shield__WEBPACK_IMPORTED_MODULE_26__ = __webpack_require__(/*! ./validate_query_shield */ "./src/helpers/validate_query_shield.ts");
/* harmony import */ var _multi_format_result__WEBPACK_IMPORTED_MODULE_27__ = __webpack_require__(/*! ./multi_format_result */ "./src/helpers/multi_format_result.ts");
/* harmony import */ var _test__WEBPACK_IMPORTED_MODULE_28__ = __webpack_require__(/*! ./test */ "./src/helpers/test/index.ts");
/* harmony import */ var _get_available_mime_type__WEBPACK_IMPORTED_MODULE_29__ = __webpack_require__(/*! ./get_available_mime_type */ "./src/helpers/get_available_mime_type.ts");
































/***/ }),

/***/ "./src/helpers/json_helper.ts":
/*!************************************!*\
  !*** ./src/helpers/json_helper.ts ***!
  \************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   JsonHelper: () => (/* binding */ JsonHelper)
/* harmony export */ });
class JsonHelper {
    static parse(value) {
        try {
            return JSON.parse(value);
        }
        catch (ex) {
            // tslint:disable-next-line
            throw {
                message: "Post data is invalid"
            };
        }
    }
    static stringify(value) {
        return JSON.stringify(value);
    }
}


/***/ }),

/***/ "./src/helpers/json_result.ts":
/*!************************************!*\
  !*** ./src/helpers/json_result.ts ***!
  \************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   jsonResult: () => (/* binding */ jsonResult)
/* harmony export */ });
/* harmony import */ var _enums__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ../enums */ "./src/enums/index.ts");
/* harmony import */ var _enums_http_status_code__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ../enums/http_status_code */ "./src/enums/http_status_code.ts");


const jsonResult = (value, statusCode) => {
    return {
        contentType: _enums__WEBPACK_IMPORTED_MODULE_0__.MIME_TYPE.Json,
        responseData: value,
        statusCode: statusCode || _enums_http_status_code__WEBPACK_IMPORTED_MODULE_1__.HTTP_STATUS_CODE.Ok,
        type: _enums__WEBPACK_IMPORTED_MODULE_0__.HTTP_RESULT_TYPE.Default
    };
};


/***/ }),

/***/ "./src/helpers/log_helper.ts":
/*!***********************************!*\
  !*** ./src/helpers/log_helper.ts ***!
  \***********************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   LogHelper: () => (/* binding */ LogHelper)
/* harmony export */ });
/* harmony import */ var _enums_error_type__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ../enums/error_type */ "./src/enums/error_type.ts");

class LogHelper {
    constructor(type, info) {
        this.type = type;
        this.info_ = info;
        this.message = this.getMsg_();
    }
    throw() {
        const errMsg = this.get();
        throw JSON.stringify(errMsg);
    }
    static log(msg) {
        console.log(msg);
    }
    logError() {
        console.error(this.get());
    }
    logWarning() {
        console.warn(this.get());
    }
    get() {
        return {
            message: this.message,
            type: this.type
        };
    }
    getMsg_() {
        let errMsg;
        switch (this.type) {
            case _enums_error_type__WEBPACK_IMPORTED_MODULE_0__.ERROR_TYPE.InvalidControllerName:
                errMsg = `Invalid controller name - '${this.info_}'. Controller name must contain 'controller'.`;
                break;
            case _enums_error_type__WEBPACK_IMPORTED_MODULE_0__.ERROR_TYPE.InvalidContentType:
                errMsg = `Content type - '${this.info_}' is not valid. Please create an issue if you think this is valid type.`;
                break;
            case _enums_error_type__WEBPACK_IMPORTED_MODULE_0__.ERROR_TYPE.PortInUse:
                errMsg = `Port ${this.info_} is being used by another process.`;
                break;
            case _enums_error_type__WEBPACK_IMPORTED_MODULE_0__.ERROR_TYPE.UndefinedViewEngine:
                errMsg = `View engine is not initiated.Initiate the view engine where fort is created.`;
                break;
            default:
                errMsg = this.message;
                break;
        }
        return errMsg;
    }
}


/***/ }),

/***/ "./src/helpers/multi_format_result.ts":
/*!********************************************!*\
  !*** ./src/helpers/multi_format_result.ts ***!
  \********************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   multiFormatResult: () => (/* binding */ multiFormatResult)
/* harmony export */ });
/* harmony import */ var _enums__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ../enums */ "./src/enums/index.ts");

const multiFormatResult = (value, statusCode) => {
    return {
        responseData: value,
        statusCode: statusCode || _enums__WEBPACK_IMPORTED_MODULE_0__.HTTP_STATUS_CODE.Ok,
        type: _enums__WEBPACK_IMPORTED_MODULE_0__.HTTP_RESULT_TYPE.FormattedResult
    };
};


/***/ }),

/***/ "./src/helpers/parse_cookie.ts":
/*!*************************************!*\
  !*** ./src/helpers/parse_cookie.ts ***!
  \*************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   parseCookie: () => (/* binding */ parseCookie)
/* harmony export */ });
/* harmony import */ var _utils__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ../utils */ "./src/utils/index.ts");

const parseCookie = (cookie) => {
    const value = {};
    if (!(0,_utils__WEBPACK_IMPORTED_MODULE_0__.isNullOrEmpty)(cookie)) {
        cookie.split(';').forEach((val) => {
            const parts = val.split('=');
            value[parts.shift().trim()] = decodeURI(parts.join('='));
        });
    }
    return value;
};


/***/ }),

/***/ "./src/helpers/parse_match_route.ts":
/*!******************************************!*\
  !*** ./src/helpers/parse_match_route.ts ***!
  \******************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   parseAndMatchRoute: () => (/* binding */ parseAndMatchRoute)
/* harmony export */ });
/* harmony import */ var _handlers_route_handler__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ../handlers/route_handler */ "./src/handlers/route_handler.ts");
/* harmony import */ var _remove_last_slash__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ./remove_last_slash */ "./src/helpers/remove_last_slash.ts");
/* harmony import */ var _utils__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! ../utils */ "./src/utils/index.ts");



const regex1 = /{(.*)}(?!.)/;
// for extension - e.g - {{file}}.js
const regex2 = /{(.*)}\.(\w+)(?!.)/;
const checkRouteInWorker = (route, httpMethod, urlParts) => {
    const matchedRoute = {
        allowedHttpMethod: [],
        controller: route.controller,
        controllerName: route.controllerName
    };
    const urlPartLength = urlParts.length;
    for (const worker of route.workers.values()) {
        const patternSplit = worker.patternSplitted;
        if (urlPartLength !== patternSplit.length)
            continue;
        let isMatched = true;
        const params = {};
        urlParts.every((urlPart, i) => {
            const patternSplitAtIndex = patternSplit[i];
            // if not equal then check for regex match
            if ((0,_utils__WEBPACK_IMPORTED_MODULE_2__.compareString)(urlPart, patternSplitAtIndex) === false) {
                const regMatch1 = patternSplitAtIndex.match(regex1);
                if (regMatch1 != null) {
                    params[regMatch1[1]] = urlPart;
                    return true;
                }
                const regMatch2 = patternSplitAtIndex.match(regex2);
                if (regMatch2 != null) {
                    const splitByDot = urlPart.split(".");
                    if (splitByDot[1] === regMatch2[2]) {
                        params[regMatch2[1]] = splitByDot[0];
                        return true;
                    }
                }
                isMatched = false;
            }
            // means its direct match
            return isMatched;
        });
        if (isMatched === true) {
            if (!worker.methodsAllowed) {
                throw `Invalid route registration in Controller : ${route.controllerName} and method : ${worker.workerName}.Route exist but method has not been decorated with worker.`;
            }
            if (worker.methodsAllowed.indexOf(httpMethod) >= 0) {
                matchedRoute.workerInfo = worker;
                matchedRoute.params = params;
                matchedRoute.shields = route.shields;
                return matchedRoute;
            }
            else {
                matchedRoute.allowedHttpMethod = [...matchedRoute.allowedHttpMethod, ...worker.methodsAllowed];
            }
        }
    }
    if (matchedRoute.allowedHttpMethod.length === 0) {
        return null;
    }
    matchedRoute.params = {};
    return matchedRoute;
};
function parseAndMatchRoute(url, httpMethod) {
    url = (0,_remove_last_slash__WEBPACK_IMPORTED_MODULE_1__.removeLastSlash)(url);
    const urlAndMethod = url + httpMethod;
    const cache = _handlers_route_handler__WEBPACK_IMPORTED_MODULE_0__.RouteHandler.getRouteFromCache(urlAndMethod);
    if (cache) {
        return cache;
    }
    const urlParts = url.split("/");
    const controllerRoute = _handlers_route_handler__WEBPACK_IMPORTED_MODULE_0__.RouteHandler.findControllerFromPath(urlParts);
    const result = controllerRoute == null ? checkRouteInWorker(_handlers_route_handler__WEBPACK_IMPORTED_MODULE_0__.RouteHandler.defaultRoute, httpMethod, urlParts) :
        checkRouteInWorker(controllerRoute, httpMethod, urlParts);
    // do not cache route which have params
    if (result && Object.keys(result.params).length === 0) {
        _handlers_route_handler__WEBPACK_IMPORTED_MODULE_0__.RouteHandler.addRouteToCache(urlAndMethod, result);
    }
    return result;
}


/***/ }),

/***/ "./src/helpers/promise.ts":
/*!********************************!*\
  !*** ./src/helpers/promise.ts ***!
  \********************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   promise: () => (/* binding */ promise)
/* harmony export */ });
const promise = (callBack) => {
    return new Promise(callBack);
};


/***/ }),

/***/ "./src/helpers/redirect_result.ts":
/*!****************************************!*\
  !*** ./src/helpers/redirect_result.ts ***!
  \****************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   redirectResult: () => (/* binding */ redirectResult)
/* harmony export */ });
/* harmony import */ var _enums__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ../enums */ "./src/enums/index.ts");
/* harmony import */ var _enums_http_status_code__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ../enums/http_status_code */ "./src/enums/http_status_code.ts");


const redirectResult = (url) => {
    return {
        contentType: _enums__WEBPACK_IMPORTED_MODULE_0__.MIME_TYPE.Text,
        responseData: url,
        statusCode: _enums_http_status_code__WEBPACK_IMPORTED_MODULE_1__.HTTP_STATUS_CODE.Redirect,
        type: _enums__WEBPACK_IMPORTED_MODULE_0__.HTTP_RESULT_TYPE.Redirect
    };
};


/***/ }),

/***/ "./src/helpers/remove_first_slash.ts":
/*!*******************************************!*\
  !*** ./src/helpers/remove_first_slash.ts ***!
  \*******************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   removeFirstSlash: () => (/* binding */ removeFirstSlash)
/* harmony export */ });
const removeFirstSlash = function (value) {
    // remove / from string at 0th index
    if (value[0] === "/") {
        return value.substring(1);
    }
    return value;
};


/***/ }),

/***/ "./src/helpers/remove_last_slash.ts":
/*!******************************************!*\
  !*** ./src/helpers/remove_last_slash.ts ***!
  \******************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   removeLastSlash: () => (/* binding */ removeLastSlash)
/* harmony export */ });
const removeLastSlash = (url) => {
    const urlLength = url.length;
    // removing / from url;
    if (url[urlLength - 1] === "/") {
        return url.substring(0, urlLength - 1);
    }
    return url;
};


/***/ }),

/***/ "./src/helpers/remove_method_and_null_from_object.ts":
/*!***********************************************************!*\
  !*** ./src/helpers/remove_method_and_null_from_object.ts ***!
  \***********************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   removeMethodAndNullFromObject: () => (/* binding */ removeMethodAndNullFromObject)
/* harmony export */ });
/* harmony import */ var _get_data_type__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ./get_data_type */ "./src/helpers/get_data_type.ts");
/* harmony import */ var _enums_data_type__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ../enums/data_type */ "./src/enums/data_type.ts");


const removeMethodAndNullFromObject = (value) => {
    const outputValue = {};
    for (const prop in value) {
        const type = (0,_get_data_type__WEBPACK_IMPORTED_MODULE_0__.getDataType)(value[prop]);
        if (!(value[prop] == null || type === _enums_data_type__WEBPACK_IMPORTED_MODULE_1__.DATA_TYPE.Function)) {
            outputValue[prop] = value[prop];
        }
    }
    return outputValue;
};


/***/ }),

/***/ "./src/helpers/render_view.ts":
/*!************************************!*\
  !*** ./src/helpers/render_view.ts ***!
  \************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   renderView: () => (/* binding */ renderView)
/* harmony export */ });
/* harmony import */ var _log_helper__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ./log_helper */ "./src/helpers/log_helper.ts");
/* harmony import */ var _enums_error_type__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ../enums/error_type */ "./src/enums/error_type.ts");
/* harmony import */ var _models__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! ../models */ "./src/models/index.ts");



let renderView;
if (false) {}
else {
    renderView = (viewName, model) => {
        if (_models__WEBPACK_IMPORTED_MODULE_2__.Fort['viewEngine_'] == null) {
            new _log_helper__WEBPACK_IMPORTED_MODULE_0__.LogHelper(_enums_error_type__WEBPACK_IMPORTED_MODULE_1__.ERROR_TYPE.UndefinedViewEngine).throw();
        }
        return _models__WEBPACK_IMPORTED_MODULE_2__.Fort['viewEngine_'].render({
            view: viewName,
            model
        });
    };
}


/***/ }),

/***/ "./src/helpers/reverse_loop.ts":
/*!*************************************!*\
  !*** ./src/helpers/reverse_loop.ts ***!
  \*************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   reverseLoop: () => (/* binding */ reverseLoop)
/* harmony export */ });
const reverseLoop = function (values, cb) {
    for (let length = values.length, i = length - 1; i >= 0; i--) {
        cb(values[i], i);
    }
};


/***/ }),

/***/ "./src/helpers/split_route.ts":
/*!************************************!*\
  !*** ./src/helpers/split_route.ts ***!
  \************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   joinRoute: () => (/* binding */ joinRoute),
/* harmony export */   splitRoute: () => (/* binding */ splitRoute)
/* harmony export */ });
const splitRoute = (value) => {
    return value.split("/");
};
const joinRoute = (value) => {
    return value.join("/");
};


/***/ }),

/***/ "./src/helpers/test/http_request_stub.ts":
/*!***********************************************!*\
  !*** ./src/helpers/test/http_request_stub.ts ***!
  \***********************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   HttpRequestStub: () => (/* binding */ HttpRequestStub)
/* harmony export */ });
class HttpRequestStub {
    constructor(headers) {
        this.headers = headers;
    }
}


/***/ }),

/***/ "./src/helpers/test/http_response_stub.ts":
/*!************************************************!*\
  !*** ./src/helpers/test/http_response_stub.ts ***!
  \************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   HttpResponseStub: () => (/* binding */ HttpResponseStub)
/* harmony export */ });
class HttpResponseStub {
    constructor(headers) {
        this.headers_ = headers;
    }
    getHeader(name) {
        return this.headers_[name];
    }
    hasHeader(name) {
        return this.headers_[name] != null;
    }
    setHeader(name, value) {
        this.headers_[name] = value;
    }
    getHeaders() {
        return this.headers_;
    }
    getHeaderNames() {
        return Object.keys[this.headers_];
    }
    removeHeader(name) {
        delete this.headers_[name];
    }
}


/***/ }),

/***/ "./src/helpers/test/index.ts":
/*!***********************************!*\
  !*** ./src/helpers/test/index.ts ***!
  \***********************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   initController: () => (/* reexport safe */ _init_controller__WEBPACK_IMPORTED_MODULE_0__.initController),
/* harmony export */   initGuard: () => (/* reexport safe */ _init_guard__WEBPACK_IMPORTED_MODULE_1__.initGuard),
/* harmony export */   initShield: () => (/* reexport safe */ _init_shield__WEBPACK_IMPORTED_MODULE_2__.initShield),
/* harmony export */   initWall: () => (/* reexport safe */ _init_wall__WEBPACK_IMPORTED_MODULE_3__.initWall)
/* harmony export */ });
/* harmony import */ var _init_controller__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ./init_controller */ "./src/helpers/test/init_controller.ts");
/* harmony import */ var _init_guard__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ./init_guard */ "./src/helpers/test/init_guard.ts");
/* harmony import */ var _init_shield__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! ./init_shield */ "./src/helpers/test/init_shield.ts");
/* harmony import */ var _init_wall__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! ./init_wall */ "./src/helpers/test/init_wall.ts");






/***/ }),

/***/ "./src/helpers/test/init_controller.ts":
/*!*********************************************!*\
  !*** ./src/helpers/test/init_controller.ts ***!
  \*********************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   initController: () => (/* binding */ initController)
/* harmony export */ });
/* harmony import */ var _models__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ../../models */ "./src/models/index.ts");
/* harmony import */ var _http_response_stub__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ./http_response_stub */ "./src/helpers/test/http_response_stub.ts");
/* harmony import */ var _http_request_stub__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! ./http_request_stub */ "./src/helpers/test/http_request_stub.ts");
/* harmony import */ var _utils__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! ../../utils */ "./src/utils/index.ts");




const initController = (controllerInstance, data) => {
    data = data || {};
    const parsedCookies = data.cookieValue || {};
    const headers = (data.request && data.request.headers) || {};
    const cookie = new _models__WEBPACK_IMPORTED_MODULE_0__.CookieManager(parsedCookies);
    const session = new _utils__WEBPACK_IMPORTED_MODULE_3__.SessionManager(cookie, _models__WEBPACK_IMPORTED_MODULE_0__.Fort);
    controllerInstance['componentProp_'] = {
        request: new _http_request_stub__WEBPACK_IMPORTED_MODULE_2__.HttpRequestStub(headers),
        response: new _http_response_stub__WEBPACK_IMPORTED_MODULE_1__.HttpResponseStub(headers),
        query: data.query || {},
        body: data.body || {},
        cookie: cookie,
        session: session,
        param: data.param || {},
        data: data.data || {},
        file: new _models__WEBPACK_IMPORTED_MODULE_0__.FileManager(data.file || {}),
        workerInfo: {
            workerName: data.workerName
        },
        global: _models__WEBPACK_IMPORTED_MODULE_0__.Fort,
        cache: _models__WEBPACK_IMPORTED_MODULE_0__.Fort['cacheManager_']
    };
    return controllerInstance;
};


/***/ }),

/***/ "./src/helpers/test/init_guard.ts":
/*!****************************************!*\
  !*** ./src/helpers/test/init_guard.ts ***!
  \****************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   initGuard: () => (/* binding */ initGuard)
/* harmony export */ });
/* harmony import */ var _init_controller__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ./init_controller */ "./src/helpers/test/init_controller.ts");

const initGuard = (guardInstance, data) => {
    return (0,_init_controller__WEBPACK_IMPORTED_MODULE_0__.initController)(guardInstance, data);
};


/***/ }),

/***/ "./src/helpers/test/init_shield.ts":
/*!*****************************************!*\
  !*** ./src/helpers/test/init_shield.ts ***!
  \*****************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   initShield: () => (/* binding */ initShield)
/* harmony export */ });
/* harmony import */ var _init_controller__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ./init_controller */ "./src/helpers/test/init_controller.ts");

const initShield = (shieldInstance, data) => {
    const value = (0,_init_controller__WEBPACK_IMPORTED_MODULE_0__.initController)(shieldInstance, data);
    return value;
};


/***/ }),

/***/ "./src/helpers/test/init_wall.ts":
/*!***************************************!*\
  !*** ./src/helpers/test/init_wall.ts ***!
  \***************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   initWall: () => (/* binding */ initWall)
/* harmony export */ });
/* harmony import */ var _init_controller__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ./init_controller */ "./src/helpers/test/init_controller.ts");

const initWall = (wallInstance, data) => {
    return (0,_init_controller__WEBPACK_IMPORTED_MODULE_0__.initController)(wallInstance, data);
};


/***/ }),

/***/ "./src/helpers/text_result.ts":
/*!************************************!*\
  !*** ./src/helpers/text_result.ts ***!
  \************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   textResult: () => (/* binding */ textResult)
/* harmony export */ });
/* harmony import */ var _enums__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ../enums */ "./src/enums/index.ts");
/* harmony import */ var _enums_http_status_code__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ../enums/http_status_code */ "./src/enums/http_status_code.ts");


const textResult = (text, statusCode) => {
    return {
        contentType: _enums__WEBPACK_IMPORTED_MODULE_0__.MIME_TYPE.Text,
        responseData: text,
        statusCode: statusCode || _enums_http_status_code__WEBPACK_IMPORTED_MODULE_1__.HTTP_STATUS_CODE.Ok,
        type: _enums__WEBPACK_IMPORTED_MODULE_0__.HTTP_RESULT_TYPE.Default
    };
};


/***/ }),

/***/ "./src/helpers/validate_body_guard.ts":
/*!********************************************!*\
  !*** ./src/helpers/validate_body_guard.ts ***!
  \********************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   ValidateBodyGuard: () => (/* binding */ ValidateBodyGuard)
/* harmony export */ });
/* harmony import */ var _abstracts__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ../abstracts */ "./src/abstracts/index.ts");
/* harmony import */ var _execute_validate__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ./execute_validate */ "./src/helpers/execute_validate.ts");


class ValidateBodyGuard extends _abstracts__WEBPACK_IMPORTED_MODULE_0__.Guard {
    async check() {
        const componentProp = this['componentProp_'];
        const expectedBody = componentProp.workerInfo.expectedBody;
        if (expectedBody == null)
            return;
        const validationResult = await (0,_execute_validate__WEBPACK_IMPORTED_MODULE_1__.executeValidate)(componentProp.global.validator, expectedBody, this.body);
        if (validationResult.error) {
            return validationResult.error;
        }
        componentProp.body = validationResult.model;
    }
}


/***/ }),

/***/ "./src/helpers/validate_param_guard.ts":
/*!*********************************************!*\
  !*** ./src/helpers/validate_param_guard.ts ***!
  \*********************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   ValidateParamGuard: () => (/* binding */ ValidateParamGuard)
/* harmony export */ });
/* harmony import */ var _abstracts__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ../abstracts */ "./src/abstracts/index.ts");
/* harmony import */ var _execute_validate__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ./execute_validate */ "./src/helpers/execute_validate.ts");


class ValidateParamGuard extends _abstracts__WEBPACK_IMPORTED_MODULE_0__.Guard {
    async check() {
        const componentProp = this['componentProp_'];
        const expectedValue = componentProp.workerInfo.expectedParam;
        if (expectedValue == null)
            return;
        const validationResult = await (0,_execute_validate__WEBPACK_IMPORTED_MODULE_1__.executeValidate)(componentProp.global.validator, expectedValue, this.param);
        if (validationResult.error) {
            return validationResult.error;
        }
        componentProp.param = validationResult.model;
    }
}


/***/ }),

/***/ "./src/helpers/validate_query_shield.ts":
/*!**********************************************!*\
  !*** ./src/helpers/validate_query_shield.ts ***!
  \**********************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   ValidateQueryShield: () => (/* binding */ ValidateQueryShield)
/* harmony export */ });
/* harmony import */ var _abstracts__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ../abstracts */ "./src/abstracts/index.ts");
/* harmony import */ var _execute_validate__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ./execute_validate */ "./src/helpers/execute_validate.ts");


class ValidateQueryShield extends _abstracts__WEBPACK_IMPORTED_MODULE_0__.Shield {
    async protect() {
        const componentProp = this['componentProp_'];
        const expectedQuery = componentProp.workerInfo.expectedQuery;
        if (expectedQuery == null)
            return;
        const validationResult = await (0,_execute_validate__WEBPACK_IMPORTED_MODULE_1__.executeValidate)(componentProp.global.validator, expectedQuery, this.query);
        if (validationResult.error) {
            return validationResult.error;
        }
        componentProp.query = validationResult.model;
    }
}


/***/ }),

/***/ "./src/helpers/view_result.ts":
/*!************************************!*\
  !*** ./src/helpers/view_result.ts ***!
  \************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   viewResult: () => (/* binding */ viewResult)
/* harmony export */ });
/* harmony import */ var _render_view__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ./render_view */ "./src/helpers/render_view.ts");
/* harmony import */ var _enums__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ../enums */ "./src/enums/index.ts");


const viewResult = (viewName, model) => {
    return (0,_render_view__WEBPACK_IMPORTED_MODULE_0__.renderView)(viewName, model).then(viewData => {
        return {
            contentType: _enums__WEBPACK_IMPORTED_MODULE_1__.MIME_TYPE.Html,
            responseData: viewData,
            statusCode: _enums__WEBPACK_IMPORTED_MODULE_1__.HTTP_STATUS_CODE.Ok,
            type: _enums__WEBPACK_IMPORTED_MODULE_1__.HTTP_RESULT_TYPE.Default
        };
    });
};


/***/ }),

/***/ "./src/interfaces/api_cache_option.ts":
/*!********************************************!*\
  !*** ./src/interfaces/api_cache_option.ts ***!
  \********************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);



/***/ }),

/***/ "./src/interfaces/component_prop.ts":
/*!******************************************!*\
  !*** ./src/interfaces/component_prop.ts ***!
  \******************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);



/***/ }),

/***/ "./src/interfaces/controller.ts":
/*!**************************************!*\
  !*** ./src/interfaces/controller.ts ***!
  \**************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);



/***/ }),

/***/ "./src/interfaces/controller_route.ts":
/*!********************************************!*\
  !*** ./src/interfaces/controller_route.ts ***!
  \********************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);



/***/ }),

/***/ "./src/interfaces/controller_test_data.ts":
/*!************************************************!*\
  !*** ./src/interfaces/controller_test_data.ts ***!
  \************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);



/***/ }),

/***/ "./src/interfaces/etag_option.ts":
/*!***************************************!*\
  !*** ./src/interfaces/etag_option.ts ***!
  \***************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);



/***/ }),

/***/ "./src/interfaces/exception.ts":
/*!*************************************!*\
  !*** ./src/interfaces/exception.ts ***!
  \*************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);



/***/ }),

/***/ "./src/interfaces/file_result_info.ts":
/*!********************************************!*\
  !*** ./src/interfaces/file_result_info.ts ***!
  \********************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);



/***/ }),

/***/ "./src/interfaces/folder_map.ts":
/*!**************************************!*\
  !*** ./src/interfaces/folder_map.ts ***!
  \**************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);



/***/ }),

/***/ "./src/interfaces/http_cookie.ts":
/*!***************************************!*\
  !*** ./src/interfaces/http_cookie.ts ***!
  \***************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);



/***/ }),

/***/ "./src/interfaces/http_request.ts":
/*!****************************************!*\
  !*** ./src/interfaces/http_request.ts ***!
  \****************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);



/***/ }),

/***/ "./src/interfaces/http_response.ts":
/*!*****************************************!*\
  !*** ./src/interfaces/http_response.ts ***!
  \*****************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);



/***/ }),

/***/ "./src/interfaces/http_result.ts":
/*!***************************************!*\
  !*** ./src/interfaces/http_result.ts ***!
  \***************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);



/***/ }),

/***/ "./src/interfaces/index.ts":
/*!*********************************!*\
  !*** ./src/interfaces/index.ts ***!
  \*********************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony import */ var _http_cookie__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ./http_cookie */ "./src/interfaces/http_cookie.ts");
/* harmony import */ var _exception__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ./exception */ "./src/interfaces/exception.ts");
/* harmony import */ var _controller__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! ./controller */ "./src/interfaces/controller.ts");
/* harmony import */ var _route_info__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! ./route_info */ "./src/interfaces/route_info.ts");
/* harmony import */ var _worker_info__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! ./worker_info */ "./src/interfaces/worker_info.ts");
/* harmony import */ var _component_prop__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(/*! ./component_prop */ "./src/interfaces/component_prop.ts");
/* harmony import */ var _validator__WEBPACK_IMPORTED_MODULE_6__ = __webpack_require__(/*! ./validator */ "./src/interfaces/validator.ts");
/* harmony import */ var _http_result__WEBPACK_IMPORTED_MODULE_7__ = __webpack_require__(/*! ./http_result */ "./src/interfaces/http_result.ts");
/* harmony import */ var _session_store__WEBPACK_IMPORTED_MODULE_8__ = __webpack_require__(/*! ./session_store */ "./src/interfaces/session_store.ts");
/* harmony import */ var _controller_test_data__WEBPACK_IMPORTED_MODULE_9__ = __webpack_require__(/*! ./controller_test_data */ "./src/interfaces/controller_test_data.ts");
/* harmony import */ var _http_request__WEBPACK_IMPORTED_MODULE_10__ = __webpack_require__(/*! ./http_request */ "./src/interfaces/http_request.ts");
/* harmony import */ var _etag_option__WEBPACK_IMPORTED_MODULE_11__ = __webpack_require__(/*! ./etag_option */ "./src/interfaces/etag_option.ts");
/* harmony import */ var _file_result_info__WEBPACK_IMPORTED_MODULE_12__ = __webpack_require__(/*! ./file_result_info */ "./src/interfaces/file_result_info.ts");
/* harmony import */ var _folder_map__WEBPACK_IMPORTED_MODULE_13__ = __webpack_require__(/*! ./folder_map */ "./src/interfaces/folder_map.ts");
/* harmony import */ var _http_response__WEBPACK_IMPORTED_MODULE_14__ = __webpack_require__(/*! ./http_response */ "./src/interfaces/http_response.ts");
/* harmony import */ var _view_engine_data__WEBPACK_IMPORTED_MODULE_15__ = __webpack_require__(/*! ./view_engine_data */ "./src/interfaces/view_engine_data.ts");
/* harmony import */ var _multi_part_parse_result__WEBPACK_IMPORTED_MODULE_16__ = __webpack_require__(/*! ./multi_part_parse_result */ "./src/interfaces/multi_part_parse_result.ts");
/* harmony import */ var _controller_route__WEBPACK_IMPORTED_MODULE_17__ = __webpack_require__(/*! ./controller_route */ "./src/interfaces/controller_route.ts");
/* harmony import */ var _route_match__WEBPACK_IMPORTED_MODULE_18__ = __webpack_require__(/*! ./route_match */ "./src/interfaces/route_match.ts");
/* harmony import */ var _session_value__WEBPACK_IMPORTED_MODULE_19__ = __webpack_require__(/*! ./session_value */ "./src/interfaces/session_value.ts");
/* harmony import */ var _view_read_option__WEBPACK_IMPORTED_MODULE_20__ = __webpack_require__(/*! ./view_read_option */ "./src/interfaces/view_read_option.ts");
/* harmony import */ var _task_scheduler__WEBPACK_IMPORTED_MODULE_21__ = __webpack_require__(/*! ./task_scheduler */ "./src/interfaces/task_scheduler.ts");
/* harmony import */ var _api_cache_option__WEBPACK_IMPORTED_MODULE_22__ = __webpack_require__(/*! ./api_cache_option */ "./src/interfaces/api_cache_option.ts");

























/***/ }),

/***/ "./src/interfaces/multi_part_parse_result.ts":
/*!***************************************************!*\
  !*** ./src/interfaces/multi_part_parse_result.ts ***!
  \***************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);



/***/ }),

/***/ "./src/interfaces/route_info.ts":
/*!**************************************!*\
  !*** ./src/interfaces/route_info.ts ***!
  \**************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);



/***/ }),

/***/ "./src/interfaces/route_match.ts":
/*!***************************************!*\
  !*** ./src/interfaces/route_match.ts ***!
  \***************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);



/***/ }),

/***/ "./src/interfaces/session_store.ts":
/*!*****************************************!*\
  !*** ./src/interfaces/session_store.ts ***!
  \*****************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);



/***/ }),

/***/ "./src/interfaces/session_value.ts":
/*!*****************************************!*\
  !*** ./src/interfaces/session_value.ts ***!
  \*****************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);



/***/ }),

/***/ "./src/interfaces/task_scheduler.ts":
/*!******************************************!*\
  !*** ./src/interfaces/task_scheduler.ts ***!
  \******************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);



/***/ }),

/***/ "./src/interfaces/validator.ts":
/*!*************************************!*\
  !*** ./src/interfaces/validator.ts ***!
  \*************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);



/***/ }),

/***/ "./src/interfaces/view_engine_data.ts":
/*!********************************************!*\
  !*** ./src/interfaces/view_engine_data.ts ***!
  \********************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);



/***/ }),

/***/ "./src/interfaces/view_read_option.ts":
/*!********************************************!*\
  !*** ./src/interfaces/view_read_option.ts ***!
  \********************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);



/***/ }),

/***/ "./src/interfaces/worker_info.ts":
/*!***************************************!*\
  !*** ./src/interfaces/worker_info.ts ***!
  \***************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);



/***/ }),

/***/ "./src/models/components.ts":
/*!**********************************!*\
  !*** ./src/models/components.ts ***!
  \**********************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   Components: () => (/* binding */ Components)
/* harmony export */ });
/* harmony import */ var _handlers__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ../handlers */ "./src/handlers/index.ts");

class ControllerListRef {
    static getInstance(name, data) {
        const routeInfo = _handlers__WEBPACK_IMPORTED_MODULE_0__.RouteHandler.getControllerFromName(name);
        if (routeInfo) {
            const controller = new routeInfo.controller(..._handlers__WEBPACK_IMPORTED_MODULE_0__.InjectorHandler.getConstructorValues(name));
            if (data) {
                controller.initialize(data);
            }
            return controller;
        }
    }
    static getMethod(className, methodName) {
        const controller = ControllerListRef.getInstance(className);
        if (controller) {
            return controller[methodName];
        }
    }
    static executeMethod(className, methodName) {
        const controller = ControllerListRef.getInstance(className);
        if (controller) {
            return controller[methodName](..._handlers__WEBPACK_IMPORTED_MODULE_0__.InjectorHandler.getMethodValues(className, methodName, null));
        }
    }
}
class Components {
}
Components.controller = ControllerListRef;


/***/ }),

/***/ "./src/models/cookie_manager.ts":
/*!**************************************!*\
  !*** ./src/models/cookie_manager.ts ***!
  \**************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   CookieManager: () => (/* binding */ CookieManager)
/* harmony export */ });
class CookieManager {
    constructor(parsedValue) {
        this.responseCookie_ = [];
        this.cookieCollection_ = parsedValue;
    }
    /**
     * return cookie by name
     *
     * @param {string} name
     * @returns
     * @memberof CookieManager
     */
    getCookie(name) {
        return {
            name: name,
            value: this.cookieCollection_[name]
        };
    }
    /**
     * add cookie
     *
     * @param {HttpCookie} cookie
     * @memberof CookieManager
     */
    addCookie(cookie) {
        this.cookieCollection_[cookie.name] = cookie.value;
        this.responseCookie_.push(this.getCookieStringFromCookie_(cookie));
    }
    /**
     * remove cookie
     *
     * @param {HttpCookie} cookie
     * @memberof CookieManager
     */
    removeCookie(cookie) {
        this.cookieCollection_[cookie.name] = null;
        cookie.expires = new Date('Thu, 01 Jan 1970 00:00:00 GMT');
        cookie.maxAge = -1;
        this.responseCookie_.push(this.getCookieStringFromCookie_(cookie));
    }
    /**
     * collection of http cookie
     *
     * @readonly
     * @memberof CookieManager
     */
    get cookieCollection() {
        return this.cookieCollection_;
    }
    /**
     * determine whether value exist or not
     *
     * @param {string} name
     * @returns
     * @memberof CookieManager
     */
    isExist(name) {
        return this.cookieCollection_[name] != null;
    }
    getCookieStringFromCookie_(cookie) {
        const cookies = [];
        cookies.push(`${cookie.name}=${cookie.value}`);
        if (cookie.expires) {
            cookies.push(`Expires=${cookie.expires.toUTCString()}`);
        }
        if (cookie.httpOnly === true) {
            cookies.push("HttpOnly");
        }
        if (cookie.maxAge != null) {
            cookies.push(`Max-Age=${cookie.maxAge}`);
        }
        if (cookie.path) {
            cookies.push(`Path=${cookie.path}`);
        }
        if (cookie.domain) {
            cookies.push(`Domain=${cookie.domain}`);
        }
        return cookies.join('; ');
    }
}


/***/ }),

/***/ "./src/models/error_handler.ts":
/*!*************************************!*\
  !*** ./src/models/error_handler.ts ***!
  \*************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   ErrorHandler: () => (/* binding */ ErrorHandler)
/* harmony export */ });
/* harmony import */ var _helpers__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ../helpers */ "./src/helpers/index.ts");
/* harmony import */ var _enums__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ../enums */ "./src/enums/index.ts");
/* harmony import */ var _utils__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! ../utils */ "./src/utils/index.ts");



class ErrorHandler {
    onServerError(ex) {
        let errMessage = `<h1>Internal Server Error</h1>
            <h3>message : ${ex.message}</h3>`;
        if (ex.stack) {
            errMessage += `<p><b>stacktrace:</b> ${ex.stack}</p>`;
        }
        if (ex.type) {
            errMessage += `<p><b>type:</b> ${ex.type}</p>`;
        }
        return (0,_utils__WEBPACK_IMPORTED_MODULE_2__.promiseResolve)((0,_helpers__WEBPACK_IMPORTED_MODULE_0__.htmlResult)(errMessage, _enums__WEBPACK_IMPORTED_MODULE_1__.HTTP_STATUS_CODE.InternalServerError));
    }
    onBadRequest(ex) {
        let errMessage = `<h1>Bad Request</h1>`;
        if (ex.message) {
            errMessage += ` <h3>message : ${ex.message} </h3>`;
        }
        if (ex.stack) {
            errMessage += `<p><b>stacktrace:</b> ${ex.stack}</p>`;
        }
        if (ex.type) {
            errMessage += `<p><b>type:</b> ${ex.type}</p>`;
        }
        return (0,_utils__WEBPACK_IMPORTED_MODULE_2__.promiseResolve)((0,_helpers__WEBPACK_IMPORTED_MODULE_0__.htmlResult)(errMessage, _enums__WEBPACK_IMPORTED_MODULE_1__.HTTP_STATUS_CODE.BadRequest));
    }
    onForbiddenRequest() {
        return (0,_utils__WEBPACK_IMPORTED_MODULE_2__.promiseResolve)((0,_helpers__WEBPACK_IMPORTED_MODULE_0__.htmlResult)(`<h1>Forbidden</h1>`, _enums__WEBPACK_IMPORTED_MODULE_1__.HTTP_STATUS_CODE.Forbidden));
    }
    onNotAcceptableRequest() {
        return (0,_utils__WEBPACK_IMPORTED_MODULE_2__.promiseResolve)((0,_helpers__WEBPACK_IMPORTED_MODULE_0__.htmlResult)(`<h1>Not Acceptable</h1>`, _enums__WEBPACK_IMPORTED_MODULE_1__.HTTP_STATUS_CODE.NotAcceptable));
    }
    onMethodNotAllowed() {
        return (0,_utils__WEBPACK_IMPORTED_MODULE_2__.promiseResolve)((0,_helpers__WEBPACK_IMPORTED_MODULE_0__.htmlResult)(`<h1>Method Not allowed.</h1>`, _enums__WEBPACK_IMPORTED_MODULE_1__.HTTP_STATUS_CODE.MethodNotAllowed));
    }
    onNotFound(url) {
        return (0,_utils__WEBPACK_IMPORTED_MODULE_2__.promiseResolve)((0,_helpers__WEBPACK_IMPORTED_MODULE_0__.htmlResult)(`<h1>The requested resource ${url} was not found.</h1>`, _enums__WEBPACK_IMPORTED_MODULE_1__.HTTP_STATUS_CODE.NotFound));
    }
}


/***/ }),

/***/ "./src/models/file_manager.ts":
/*!************************************!*\
  !*** ./src/models/file_manager.ts ***!
  \************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   FileManager: () => (/* binding */ FileManager)
/* harmony export */ });
/* harmony import */ var fs_extra__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! fs-extra */ "fs-extra");
/* harmony import */ var fs_extra__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(fs_extra__WEBPACK_IMPORTED_MODULE_0__);

class FileManager {
    constructor(value) {
        this.files_ = value;
    }
    /**
     * get total no of files
     *
     * @returns - number
     * @memberof FileManager
     */
    get count() {
        return Object.keys(this.files_).length;
    }
    get files() {
        return Object.keys(this.files_).map(fileId => {
            return this.files_[fileId];
        });
    }
    /**
     * check for existance of file
     *
     * @param {string} fieldName
     * @returns
     * @memberof FileManager
     */
    isExist(fieldName) {
        return this.files_[fieldName] != null;
    }
    /**
     * return the file
     *
     * @param {string} fieldName
     * @returns
     * @memberof FileManager
     */
    getFile(fieldName) {
        return this.files_[fieldName];
    }
    /**
     * saves file to supplied path
     *
     * @param {string} fieldName
     * @param {string} pathToSave
     * @returns
     * @memberof FileManager
     */
    saveTo(fieldName, pathToSave) {
        return fs_extra__WEBPACK_IMPORTED_MODULE_0__.copy(this.files_[fieldName].path, pathToSave);
    }
}


/***/ }),

/***/ "./src/models/fort.ts":
/*!****************************!*\
  !*** ./src/models/fort.ts ***!
  \****************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   App: () => (/* binding */ App),
/* harmony export */   Fort: () => (/* binding */ Fort)
/* harmony export */ });
/* harmony import */ var _abstracts__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ../abstracts */ "./src/abstracts/index.ts");
/* harmony import */ var _handlers__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ../handlers */ "./src/handlers/index.ts");
/* harmony import */ var http__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! http */ "http");
/* harmony import */ var http__WEBPACK_IMPORTED_MODULE_2___default = /*#__PURE__*/__webpack_require__.n(http__WEBPACK_IMPORTED_MODULE_2__);
/* harmony import */ var _enums__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! ../enums */ "./src/enums/index.ts");
/* harmony import */ var _helpers__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! ../helpers */ "./src/helpers/index.ts");
/* harmony import */ var _utils__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(/*! ../utils */ "./src/utils/index.ts");
/* harmony import */ var _logger__WEBPACK_IMPORTED_MODULE_6__ = __webpack_require__(/*! ./logger */ "./src/models/logger.ts");
/* harmony import */ var _constants__WEBPACK_IMPORTED_MODULE_7__ = __webpack_require__(/*! ../constants */ "./src/constants/index.ts");
/* harmony import */ var _providers__WEBPACK_IMPORTED_MODULE_8__ = __webpack_require__(/*! ../providers */ "./src/providers/index.ts");
/* harmony import */ var _extra__WEBPACK_IMPORTED_MODULE_9__ = __webpack_require__(/*! ../extra */ "./src/extra/index.ts");
/* harmony import */ var _error_handler__WEBPACK_IMPORTED_MODULE_10__ = __webpack_require__(/*! ./error_handler */ "./src/models/error_handler.ts");











class App {
    constructor() {
        /**
         * Whether to parse cookie or not, default - true
         * If false, then session wont work.
         *
         * @type {boolean}
         * @memberof App
         */
        this.shouldParseCookie = true;
        /**
         * Whether to parse the http body data in post request, default - true
         *
         * @type {boolean}
         * @memberof App
         */
        this.shouldParseBody = true;
        /**
         * session timeout in minute - default is 60 minute
         *
         * @type {number}
         * @memberof App
         */
        this.sessionTimeOut = 60;
        this.componentOption_ = new _abstracts__WEBPACK_IMPORTED_MODULE_0__.ComponentOption();
        this.walls = [];
        /**
         * keep alive timeout in millisecond for requests, default is 72000
         *
         * @memberof App
         */
        this.keepAliveTimeout = 30000;
        this.folders_ = [];
        this.shields = [];
        this.guards = [];
        /**
         * port at which app will listen, default - 4000
         *
         * @private
         * @memberof App
         */
        this.port = 4000;
        this.onNewRequest = (request, response) => {
            new _handlers__WEBPACK_IMPORTED_MODULE_1__.RequestHandler(this).handle(request, response);
        };
        this.crons = [];
        this.scheduler = new _utils__WEBPACK_IMPORTED_MODULE_5__.TaskSchedulerManager(this);
        this.cronJobScheduler = _providers__WEBPACK_IMPORTED_MODULE_8__.DefaultCronJobScheduler;
    }
    set logger(value) {
        this.logger_ = typeof value === 'function' ? new this.value() :
            value;
    }
    get logger() {
        return this.logger_;
    }
    set routes(value) {
        if (value == null) {
            value = [];
        }
        let isDefaultRouteExist = false;
        function addChildRoute(route) {
            route.children && route.children.forEach(childrenRoute => {
                childrenRoute.path = (0,_helpers__WEBPACK_IMPORTED_MODULE_4__.removeFirstSlash)(childrenRoute.path);
                childrenRoute.path = (0,_helpers__WEBPACK_IMPORTED_MODULE_4__.removeLastSlash)(childrenRoute.path);
                addChildRoute(childrenRoute);
            });
        }
        // removing / from routes
        value.forEach(route => {
            // route.path = removeFirstSlash(route.path);
            route.path = (0,_helpers__WEBPACK_IMPORTED_MODULE_4__.removeLastSlash)(route.path);
            addChildRoute(route);
            _handlers__WEBPACK_IMPORTED_MODULE_1__.RouteHandler.addToRouterCollection(route);
            if (route.path === "/*") {
                _handlers__WEBPACK_IMPORTED_MODULE_1__.RouteHandler.defaultRouteControllerName = route.controller.name;
                isDefaultRouteExist = true;
            }
        });
        if (isDefaultRouteExist === false) {
            class GenericController extends _abstracts__WEBPACK_IMPORTED_MODULE_0__.Controller {
            }
            _handlers__WEBPACK_IMPORTED_MODULE_1__.RouteHandler.defaultRouteControllerName = GenericController.name;
            _handlers__WEBPACK_IMPORTED_MODULE_1__.RouteHandler.addToRouterCollection({
                controller: GenericController,
                path: "/*",
                children: null
            });
        }
    }
    /**
     * view engine use to render the view
     *
     * @
     * @memberof Fort
     */
    set viewEngine(value) {
        this.viewEngine_ = new value();
    }
    set resultMapper(value) {
        (0,_helpers__WEBPACK_IMPORTED_MODULE_4__.setResultMapper)(value);
    }
    set componentOption(value) {
        this.componentOption_ = new value();
    }
    /**
     * folders which should be visible to requests. By default nothing is allowed.
     *
     * @
     * @memberof Fort
     */
    set folders(value) {
        value = value || [];
        if ((0,_utils__WEBPACK_IMPORTED_MODULE_5__.isArray)(value) === false) {
            throw new Error(`folders should be an array`);
        }
        // remove / from files routes
        value.forEach(folder => {
            const length = folder.alias.length;
            if (length > 1) {
                folder.alias = (0,_helpers__WEBPACK_IMPORTED_MODULE_4__.removeFirstSlash)(folder.alias);
                folder.alias = (0,_helpers__WEBPACK_IMPORTED_MODULE_4__.removeLastSlash)(folder.alias);
            }
        });
        this.folders_ = value;
    }
    create() {
        const setDefault = () => {
            this.viewPath = this.viewPath || _constants__WEBPACK_IMPORTED_MODULE_7__.CURRENT_PATH;
            this.logger = this.logger || new _logger__WEBPACK_IMPORTED_MODULE_6__.Logger();
            this.sessionStore = this.sessionStore || _providers__WEBPACK_IMPORTED_MODULE_8__.MemorySessionStore;
            this.cacheStore = this.cacheStore || new _providers__WEBPACK_IMPORTED_MODULE_8__.MemoryCacheStore();
            this.xmlParser = this.xmlParser || _providers__WEBPACK_IMPORTED_MODULE_8__.BlankXmlParser;
            this.viewEngine_ = this.viewEngine_ || new _extra__WEBPACK_IMPORTED_MODULE_9__.MustacheViewEngine();
            this.appName = this.appName || _constants__WEBPACK_IMPORTED_MODULE_7__.APP_NAME;
            if (this.eTag == null) {
                this.eTag = {
                    type: _enums__WEBPACK_IMPORTED_MODULE_3__.ETAG_TYPE.Weak
                };
            }
            this.errorHandler = this.errorHandler || _error_handler__WEBPACK_IMPORTED_MODULE_10__.ErrorHandler;
            this.validator = this.validator || new _extra__WEBPACK_IMPORTED_MODULE_9__.DtoValidator();
            this.appSessionIdentifier_ = `${this.appName}_session_id`;
            if (this.shouldParseCookie === true) {
                this.walls.unshift(_providers__WEBPACK_IMPORTED_MODULE_8__.CookieEvaluatorWall);
            }
            if (this.useCache === true) {
                this.walls.push(_providers__WEBPACK_IMPORTED_MODULE_8__.CacheWall);
                this.guards.push(_providers__WEBPACK_IMPORTED_MODULE_8__.CacheGuard);
                this.cacheManager_ = new _utils__WEBPACK_IMPORTED_MODULE_5__.CacheManager(this.cacheStore);
            }
            if (this.shouldParseBody === true) {
                this.guards.unshift(_providers__WEBPACK_IMPORTED_MODULE_8__.PostDataEvaluatorGuard);
            }
            const shouldEnableCache = this.useCache;
            // add global shields
            _handlers__WEBPACK_IMPORTED_MODULE_1__.RouteHandler.routerCollection.forEach((route) => {
                route.shields = this.shields.concat(route.shields);
                route.workers.forEach((worker) => {
                    worker.guards = this.guards.concat(worker.guards);
                    if (shouldEnableCache === true) {
                        worker.guards.push(_providers__WEBPACK_IMPORTED_MODULE_8__.CacheGuard);
                    }
                });
            });
        };
        setDefault();
        if (this.httpServer != null) {
            return;
        }
        return (0,_helpers__WEBPACK_IMPORTED_MODULE_4__.promise)((res, rej) => {
            this.httpServer = http__WEBPACK_IMPORTED_MODULE_2__.createServer(this.onNewRequest).once("error", (err) => {
                if (err.code === 'EADDRINUSE') {
                    const error = new _helpers__WEBPACK_IMPORTED_MODULE_4__.LogHelper(_enums__WEBPACK_IMPORTED_MODULE_3__.ERROR_TYPE.PortInUse, this.port).get();
                    rej(error);
                }
                else {
                    rej(err);
                }
            }).once('listening', () => {
                res();
            }).listen(this.port);
            this.httpServer.keepAliveTimeout = this.keepAliveTimeout;
        });
    }
    destroy() {
        this.scheduler.stopAll();
        return (0,_helpers__WEBPACK_IMPORTED_MODULE_4__.promise)((res, rej) => {
            this.httpServer.close((err) => {
                if (err) {
                    rej(err);
                }
                else {
                    res();
                }
            });
        });
    }
}
const Fort = new App();


/***/ }),

/***/ "./src/models/http_cookie.ts":
/*!***********************************!*\
  !*** ./src/models/http_cookie.ts ***!
  \***********************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   HttpCookie: () => (/* binding */ HttpCookie)
/* harmony export */ });
class HttpCookie {
    constructor(name, value) {
        this.name = name;
        this.value = value;
    }
}


/***/ }),

/***/ "./src/models/http_file.ts":
/*!*********************************!*\
  !*** ./src/models/http_file.ts ***!
  \*********************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   HttpFile: () => (/* binding */ HttpFile)
/* harmony export */ });
class HttpFile {
}


/***/ }),

/***/ "./src/models/index.ts":
/*!*****************************!*\
  !*** ./src/models/index.ts ***!
  \*****************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   App: () => (/* reexport safe */ _fort__WEBPACK_IMPORTED_MODULE_2__.App),
/* harmony export */   Components: () => (/* reexport safe */ _components__WEBPACK_IMPORTED_MODULE_9__.Components),
/* harmony export */   CookieManager: () => (/* reexport safe */ _cookie_manager__WEBPACK_IMPORTED_MODULE_4__.CookieManager),
/* harmony export */   ErrorHandler: () => (/* reexport safe */ _error_handler__WEBPACK_IMPORTED_MODULE_0__.ErrorHandler),
/* harmony export */   FileManager: () => (/* reexport safe */ _file_manager__WEBPACK_IMPORTED_MODULE_5__.FileManager),
/* harmony export */   Fort: () => (/* reexport safe */ _fort__WEBPACK_IMPORTED_MODULE_2__.Fort),
/* harmony export */   HttpCookie: () => (/* reexport safe */ _http_cookie__WEBPACK_IMPORTED_MODULE_1__.HttpCookie),
/* harmony export */   HttpFile: () => (/* reexport safe */ _http_file__WEBPACK_IMPORTED_MODULE_6__.HttpFile),
/* harmony export */   Logger: () => (/* reexport safe */ _logger__WEBPACK_IMPORTED_MODULE_7__.Logger),
/* harmony export */   RouteInfo: () => (/* reexport safe */ _route_info__WEBPACK_IMPORTED_MODULE_8__.RouteInfo),
/* harmony export */   Router: () => (/* reexport safe */ _router__WEBPACK_IMPORTED_MODULE_3__.Router),
/* harmony export */   WorkerInfo: () => (/* reexport safe */ _worker_info__WEBPACK_IMPORTED_MODULE_10__.WorkerInfo)
/* harmony export */ });
/* harmony import */ var _error_handler__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ./error_handler */ "./src/models/error_handler.ts");
/* harmony import */ var _http_cookie__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ./http_cookie */ "./src/models/http_cookie.ts");
/* harmony import */ var _fort__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! ./fort */ "./src/models/fort.ts");
/* harmony import */ var _router__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! ./router */ "./src/models/router.ts");
/* harmony import */ var _cookie_manager__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! ./cookie_manager */ "./src/models/cookie_manager.ts");
/* harmony import */ var _file_manager__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(/*! ./file_manager */ "./src/models/file_manager.ts");
/* harmony import */ var _http_file__WEBPACK_IMPORTED_MODULE_6__ = __webpack_require__(/*! ./http_file */ "./src/models/http_file.ts");
/* harmony import */ var _logger__WEBPACK_IMPORTED_MODULE_7__ = __webpack_require__(/*! ./logger */ "./src/models/logger.ts");
/* harmony import */ var _route_info__WEBPACK_IMPORTED_MODULE_8__ = __webpack_require__(/*! ./route_info */ "./src/models/route_info.ts");
/* harmony import */ var _components__WEBPACK_IMPORTED_MODULE_9__ = __webpack_require__(/*! ./components */ "./src/models/components.ts");
/* harmony import */ var _worker_info__WEBPACK_IMPORTED_MODULE_10__ = __webpack_require__(/*! ./worker_info */ "./src/models/worker_info.ts");













/***/ }),

/***/ "./src/models/logger.ts":
/*!******************************!*\
  !*** ./src/models/logger.ts ***!
  \******************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   Logger: () => (/* binding */ Logger)
/* harmony export */ });
class Logger {
    info(...args) {
        this.debug(args);
    }
    error(...args) {
        this.debug(args);
    }
    log(...args) {
        this.debug(args);
    }
    debug(...args) {
        console.log(...args);
    }
}


/***/ }),

/***/ "./src/models/route_info.ts":
/*!**********************************!*\
  !*** ./src/models/route_info.ts ***!
  \**********************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   RouteInfo: () => (/* binding */ RouteInfo)
/* harmony export */ });
class RouteInfo {
    get workersAsArray() {
        return Array.from(this.workers.keys()).map(workerName => {
            return this.workers.get(workerName);
        });
    }
    constructor(value) {
        this.controllerName = value.controllerName;
        this.controller = value.controller;
        this.path = value.path;
        this.shields = value.shields;
        this.values = value.values;
        this.workers = value.workers;
        this.partialRoutes = value.partialRoutes;
    }
    set path(value) {
        this.path_ = value;
        this.pathSplitted = value ? value.split("/") : [];
    }
    get path() {
        return this.path_;
    }
}


/***/ }),

/***/ "./src/models/router.ts":
/*!******************************!*\
  !*** ./src/models/router.ts ***!
  \******************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   Router: () => (/* binding */ Router)
/* harmony export */ });
/* harmony import */ var _handlers__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ../handlers */ "./src/handlers/index.ts");

class Router {
    get routes() {
        return _handlers__WEBPACK_IMPORTED_MODULE_0__.RouteHandler.routerCollection;
    }
    get routesAsArray() {
        return _handlers__WEBPACK_IMPORTED_MODULE_0__.RouteHandler.routesAsArray;
    }
}


/***/ }),

/***/ "./src/models/worker_info.ts":
/*!***********************************!*\
  !*** ./src/models/worker_info.ts ***!
  \***********************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   WorkerInfo: () => (/* binding */ WorkerInfo)
/* harmony export */ });
/* harmony import */ var _helpers__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ../helpers */ "./src/helpers/index.ts");

class WorkerInfo {
    constructor(value) {
        this.workerName = value.workerName;
        this.methodsAllowed = value.methodsAllowed;
        this.guards = value.guards;
        this.values = value.values;
        this.expectedQuery = value.expectedQuery;
        this.expectedBody = value.expectedBody;
        this.expectedParam = value.expectedParam;
        this.pattern = value.pattern;
        this.cache = value.cache;
    }
    set pattern(value) {
        this.patternSplitted = (0,_helpers__WEBPACK_IMPORTED_MODULE_0__.splitRoute)(value || "");
    }
    get pattern() {
        return (0,_helpers__WEBPACK_IMPORTED_MODULE_0__.joinRoute)(this.patternSplitted);
    }
}


/***/ }),

/***/ "./src/providers/cache_guard.ts":
/*!**************************************!*\
  !*** ./src/providers/cache_guard.ts ***!
  \**************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   CacheGuard: () => (/* binding */ CacheGuard)
/* harmony export */ });
/* harmony import */ var _abstracts__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ../abstracts */ "./src/abstracts/index.ts");
/* harmony import */ var _constants__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ../constants */ "./src/constants/index.ts");
/* harmony import */ var _enums__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! ../enums */ "./src/enums/index.ts");



class CacheGuard extends _abstracts__WEBPACK_IMPORTED_MODULE_0__.Guard {
    async check() {
        if (this.request.method !== _enums__WEBPACK_IMPORTED_MODULE_2__.HTTP_METHOD.Get) {
            // set cache true to allow walls to not cache data;
            this.data[_constants__WEBPACK_IMPORTED_MODULE_1__.FROM_CACHE] = true;
            return;
        }
        // get cache condition from routes
        const componentProp = this['componentProp_'];
        const cacheInfo = componentProp.workerInfo.cache;
        if (!cacheInfo)
            return;
        const cacheData = await componentProp.cache.get(cacheInfo.key);
        // and check if condition exist
        if (cacheData) {
            // then return cache result
            this.data[_constants__WEBPACK_IMPORTED_MODULE_1__.FROM_CACHE] = true;
            return cacheData.data;
        }
    }
}


/***/ }),

/***/ "./src/providers/cache_wall.ts":
/*!*************************************!*\
  !*** ./src/providers/cache_wall.ts ***!
  \*************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   CacheWall: () => (/* binding */ CacheWall)
/* harmony export */ });
/* harmony import */ var _abstracts__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ../abstracts */ "./src/abstracts/index.ts");
/* harmony import */ var _constants__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ../constants */ "./src/constants/index.ts");


function isCacheable(cacheConditionData, data2) {
    if (cacheConditionData) {
        for (const key in cacheConditionData) {
            if (cacheConditionData[key] !== data2[key]) {
                return;
            }
        }
    }
    return true;
}
class CacheWall extends _abstracts__WEBPACK_IMPORTED_MODULE_0__.Wall {
    async onIncoming() {
        this['componentProp_'].cache = this['componentProp_'].global['cacheManager_'];
    }
    onOutgoing(finalResult) {
        // return if request is exited from cache guard
        if (this.data[_constants__WEBPACK_IMPORTED_MODULE_1__.FROM_CACHE])
            return;
        // get cache condition from routes
        const componentProp = this['componentProp_'];
        const cacheInfo = componentProp.workerInfo?.cache;
        if (!cacheInfo)
            return;
        // and check if condition exist
        if (!isCacheable(cacheInfo.query, componentProp.query)) {
            return;
        }
        if (!isCacheable(cacheInfo.param, componentProp.param)) {
            return;
        }
        // then cache result
        componentProp.cache.set(cacheInfo.key, finalResult, cacheInfo.ttl);
    }
}


/***/ }),

/***/ "./src/providers/cookie_wall.ts":
/*!**************************************!*\
  !*** ./src/providers/cookie_wall.ts ***!
  \**************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   CookieEvaluatorWall: () => (/* binding */ CookieEvaluatorWall)
/* harmony export */ });
/* harmony import */ var _abstracts__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ../abstracts */ "./src/abstracts/index.ts");
/* harmony import */ var _constants__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ../constants */ "./src/constants/index.ts");
/* harmony import */ var _helpers__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! ../helpers */ "./src/helpers/index.ts");
/* harmony import */ var _models__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! ../models */ "./src/models/index.ts");
/* harmony import */ var _utils__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! ../utils */ "./src/utils/index.ts");





class CookieEvaluatorWall extends _abstracts__WEBPACK_IMPORTED_MODULE_0__.Wall {
    parseCookieFromRequest() {
        const componentProps = this['componentProp_'];
        const appGlobal = componentProps.global;
        if (appGlobal.shouldParseCookie === false) {
            componentProps.cookie = new _models__WEBPACK_IMPORTED_MODULE_3__.CookieManager({});
            return;
        }
        const request = this.request;
        const rawCookie = (request.headers[_constants__WEBPACK_IMPORTED_MODULE_1__.COOKIE] || request.headers["cookie"]);
        const parsedCookies = (0,_helpers__WEBPACK_IMPORTED_MODULE_2__.parseCookie)(rawCookie);
        const cookie = new _models__WEBPACK_IMPORTED_MODULE_3__.CookieManager(parsedCookies);
        const session = new _utils__WEBPACK_IMPORTED_MODULE_4__.SessionManager(cookie, appGlobal);
        componentProps.session = session;
        componentProps.cookie = cookie;
    }
    async onIncoming() {
        this.parseCookieFromRequest();
    }
}


/***/ }),

/***/ "./src/providers/cron_job_scheduler.ts":
/*!*********************************************!*\
  !*** ./src/providers/cron_job_scheduler.ts ***!
  \*********************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   DefaultCronJobScheduler: () => (/* binding */ DefaultCronJobScheduler)
/* harmony export */ });
/* harmony import */ var cron__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! cron */ "cron");
/* harmony import */ var cron__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(cron__WEBPACK_IMPORTED_MODULE_0__);

class DefaultCronJobScheduler {
    constructor(cronTask) {
        // Dynamically import the cron package
        // eslint-disable-next-line
        this.job_ = new cron__WEBPACK_IMPORTED_MODULE_0__.CronJob(cronTask.expression, async () => {
            try {
                await cronTask.execute();
            }
            catch (ex) {
                cronTask['appGlobal_'].logger.error(ex);
            }
            cronTask.onComplete();
        });
    }
    start() {
        return this.job_.start();
    }
    stop() {
        return this.job_.stop();
    }
}


/***/ }),

/***/ "./src/providers/generic_xml_parser.ts":
/*!*********************************************!*\
  !*** ./src/providers/generic_xml_parser.ts ***!
  \*********************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   BlankXmlParser: () => (/* binding */ BlankXmlParser)
/* harmony export */ });
class BlankXmlParser {
    parse() {
        // tslint:disable-next-line
        throw {
            message: "no xml parser configured"
        };
    }
}


/***/ }),

/***/ "./src/providers/index.ts":
/*!********************************!*\
  !*** ./src/providers/index.ts ***!
  \********************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   BlankXmlParser: () => (/* reexport safe */ _generic_xml_parser__WEBPACK_IMPORTED_MODULE_3__.BlankXmlParser),
/* harmony export */   CacheGuard: () => (/* reexport safe */ _cache_guard__WEBPACK_IMPORTED_MODULE_5__.CacheGuard),
/* harmony export */   CacheWall: () => (/* reexport safe */ _cache_wall__WEBPACK_IMPORTED_MODULE_6__.CacheWall),
/* harmony export */   CookieEvaluatorWall: () => (/* reexport safe */ _cookie_wall__WEBPACK_IMPORTED_MODULE_0__.CookieEvaluatorWall),
/* harmony export */   DefaultCronJobScheduler: () => (/* reexport safe */ _cron_job_scheduler__WEBPACK_IMPORTED_MODULE_7__.DefaultCronJobScheduler),
/* harmony export */   MemoryCacheStore: () => (/* reexport safe */ _memory_api_cache_store__WEBPACK_IMPORTED_MODULE_4__.MemoryCacheStore),
/* harmony export */   MemorySessionStore: () => (/* reexport safe */ _memory_session_store__WEBPACK_IMPORTED_MODULE_2__.MemorySessionStore),
/* harmony export */   PostDataEvaluatorGuard: () => (/* reexport safe */ _post_data_evaluator_guard__WEBPACK_IMPORTED_MODULE_1__.PostDataEvaluatorGuard)
/* harmony export */ });
/* harmony import */ var _cookie_wall__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ./cookie_wall */ "./src/providers/cookie_wall.ts");
/* harmony import */ var _post_data_evaluator_guard__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ./post_data_evaluator_guard */ "./src/providers/post_data_evaluator_guard.ts");
/* harmony import */ var _memory_session_store__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! ./memory_session_store */ "./src/providers/memory_session_store.ts");
/* harmony import */ var _generic_xml_parser__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! ./generic_xml_parser */ "./src/providers/generic_xml_parser.ts");
/* harmony import */ var _memory_api_cache_store__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! ./memory_api_cache_store */ "./src/providers/memory_api_cache_store.ts");
/* harmony import */ var _cache_guard__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(/*! ./cache_guard */ "./src/providers/cache_guard.ts");
/* harmony import */ var _cache_wall__WEBPACK_IMPORTED_MODULE_6__ = __webpack_require__(/*! ./cache_wall */ "./src/providers/cache_wall.ts");
/* harmony import */ var _cron_job_scheduler__WEBPACK_IMPORTED_MODULE_7__ = __webpack_require__(/*! ./cron_job_scheduler */ "./src/providers/cron_job_scheduler.ts");










/***/ }),

/***/ "./src/providers/memory_api_cache_store.ts":
/*!*************************************************!*\
  !*** ./src/providers/memory_api_cache_store.ts ***!
  \*************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   MemoryCacheStore: () => (/* binding */ MemoryCacheStore)
/* harmony export */ });
const store = new Map();
class MemoryCacheStore {
    async set(option) {
        store.set(option.key, option);
    }
    async get(key) {
        return store.get(key);
    }
    async delete(key) {
        return store.delete(key);
    }
    count() {
        return store.size;
    }
    store() {
        return store;
    }
}


/***/ }),

/***/ "./src/providers/memory_session_store.ts":
/*!***********************************************!*\
  !*** ./src/providers/memory_session_store.ts ***!
  \***********************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   MemorySessionStore: () => (/* binding */ MemorySessionStore)
/* harmony export */ });
const sessionValues = new Map();
class MemorySessionStore {
    constructor(sessionId) {
        this.sessionId = sessionId;
    }
    getSessionValue_() {
        return sessionValues.get(this.sessionId);
    }
    async isAnyExist() {
        return this.getSessionValue_() != null;
    }
    async get(key) {
        const savedValue = this.getSessionValue_();
        return savedValue != null ? savedValue[key] : null;
    }
    async getAll() {
        const savedValue = this.getSessionValue_();
        return savedValue || {};
    }
    async isExist(key) {
        const savedValue = this.getSessionValue_();
        return savedValue == null ? false : savedValue[key] != null;
    }
    async clear() {
        // remove session values
        sessionValues.delete(this.sessionId);
    }
    async set(key, val) {
        const savedValue = this.getSessionValue_();
        if (savedValue == null) {
            sessionValues.set(this.sessionId, {
                [key]: val
            });
        }
        else {
            savedValue[key] = val;
        }
    }
    setMany(values) {
        return Promise.all(Object.keys(values).map((key) => {
            return this.set(key, values[key]);
        }));
    }
    async remove(key) {
        const savedValue = this.getSessionValue_();
        if (savedValue != null) {
            savedValue[key] = null;
        }
    }
}


/***/ }),

/***/ "./src/providers/post_data_evaluator_guard.ts":
/*!****************************************************!*\
  !*** ./src/providers/post_data_evaluator_guard.ts ***!
  \****************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   PostDataEvaluatorGuard: () => (/* binding */ PostDataEvaluatorGuard)
/* harmony export */ });
/* harmony import */ var _abstracts__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ../abstracts */ "./src/abstracts/index.ts");
/* harmony import */ var _enums__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ../enums */ "./src/enums/index.ts");
/* harmony import */ var _helpers__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! ../helpers */ "./src/helpers/index.ts");
/* harmony import */ var _models__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! ../models */ "./src/models/index.ts");
/* harmony import */ var fast_content_type_parse__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! fast-content-type-parse */ "fast-content-type-parse");
/* harmony import */ var fast_content_type_parse__WEBPACK_IMPORTED_MODULE_4___default = /*#__PURE__*/__webpack_require__.n(fast_content_type_parse__WEBPACK_IMPORTED_MODULE_4__);
/* harmony import */ var querystring__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(/*! querystring */ "querystring");
/* harmony import */ var querystring__WEBPACK_IMPORTED_MODULE_5___default = /*#__PURE__*/__webpack_require__.n(querystring__WEBPACK_IMPORTED_MODULE_5__);
/* harmony import */ var multiparty__WEBPACK_IMPORTED_MODULE_6__ = __webpack_require__(/*! multiparty */ "multiparty");
/* harmony import */ var multiparty__WEBPACK_IMPORTED_MODULE_6___default = /*#__PURE__*/__webpack_require__.n(multiparty__WEBPACK_IMPORTED_MODULE_6__);








class PostDataEvaluatorGuard extends _abstracts__WEBPACK_IMPORTED_MODULE_0__.Guard {
    async check() {
        try {
            const postResult = await this.handlePostData();
            const componentProps = this['componentProp_'];
            componentProps.file = postResult[0];
            componentProps.body = postResult[1];
        }
        catch (error) {
            return (0,_helpers__WEBPACK_IMPORTED_MODULE_2__.textResult)(error.message || `Invalid body data. Check your data format.`, _enums__WEBPACK_IMPORTED_MODULE_1__.HTTP_STATUS_CODE.BadRequest);
        }
    }
    async handlePostData() {
        if (this.request.method === _enums__WEBPACK_IMPORTED_MODULE_1__.HTTP_METHOD.Get) {
            return [new _models__WEBPACK_IMPORTED_MODULE_3__.FileManager({}), {}];
        }
        return this.parsePostData();
    }
    getPostRawData_() {
        const body = [];
        return (0,_helpers__WEBPACK_IMPORTED_MODULE_2__.promise)((res, rej) => {
            this.request.on('data', (chunk) => {
                body.push(chunk);
            }).on('end', () => {
                const bodyBuffer = Buffer.concat(body);
                res(bodyBuffer.toString());
            }).on("error", function (err) {
                rej(err);
            });
        });
    }
    parseMultiPartData_() {
        return (0,_helpers__WEBPACK_IMPORTED_MODULE_2__.promise)((res, rej) => {
            new multiparty__WEBPACK_IMPORTED_MODULE_6__.Form().parse(this.request, (err, fields, files) => {
                if (err) {
                    rej(err);
                }
                else {
                    const result = {
                        field: {},
                        file: {}
                    };
                    for (const field in fields) {
                        result.field[field] = fields[field].length === 1 ? fields[field][0] : fields[field];
                    }
                    for (const file in files) {
                        result.file[file] = files[file].length === 1 ? files[file][0] : files[file];
                    }
                    res(result);
                }
            });
        });
    }
    async parsePostData() {
        let contentType = this.request.headers["content-type"];
        if (contentType != null) {
            contentType = fast_content_type_parse__WEBPACK_IMPORTED_MODULE_4___default().parse(contentType).type;
        }
        if (contentType === _enums__WEBPACK_IMPORTED_MODULE_1__.MIME_TYPE.FormMultiPart) {
            const multipartyResult = await this.parseMultiPartData_();
            return [new _models__WEBPACK_IMPORTED_MODULE_3__.FileManager(multipartyResult.file), multipartyResult.field];
        }
        else {
            let postData;
            const bodyDataAsString = await this.getPostRawData_();
            switch (contentType) {
                case _enums__WEBPACK_IMPORTED_MODULE_1__.MIME_TYPE.Json:
                    postData = _helpers__WEBPACK_IMPORTED_MODULE_2__.JsonHelper.parse(bodyDataAsString);
                    break;
                case _enums__WEBPACK_IMPORTED_MODULE_1__.MIME_TYPE.Text:
                case _enums__WEBPACK_IMPORTED_MODULE_1__.MIME_TYPE.Html:
                    postData = bodyDataAsString;
                    break;
                case _enums__WEBPACK_IMPORTED_MODULE_1__.MIME_TYPE.FormUrlEncoded:
                    postData = querystring__WEBPACK_IMPORTED_MODULE_5__.parse(bodyDataAsString);
                    break;
                case _enums__WEBPACK_IMPORTED_MODULE_1__.MIME_TYPE.Xml:
                    postData = new this['componentProp_'].global.xmlParser().parse(bodyDataAsString);
                    break;
                default:
                    postData = {};
            }
            return [new _models__WEBPACK_IMPORTED_MODULE_3__.FileManager({}), postData];
        }
    }
}


/***/ }),

/***/ "./src/types/http_format_result.ts":
/*!*****************************************!*\
  !*** ./src/types/http_format_result.ts ***!
  \*****************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);



/***/ }),

/***/ "./src/types/index.ts":
/*!****************************!*\
  !*** ./src/types/index.ts ***!
  \****************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony import */ var _http_format_result__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ./http_format_result */ "./src/types/http_format_result.ts");



/***/ }),

/***/ "./src/utils/cache_manager.ts":
/*!************************************!*\
  !*** ./src/utils/cache_manager.ts ***!
  \************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   CacheManager: () => (/* binding */ CacheManager)
/* harmony export */ });
class CacheManager {
    constructor(cacheStore_) {
        this.cacheStore_ = cacheStore_;
    }
    /**
     * set the cache by supplying key and value
     *
     * @param {*} key
     * @param {*} data
     * @param {number} [ttl=600] - time to live in second, default 600
     * @memberof CacheManager
     */
    async set(key, data, ttl = 600) {
        const cacheData = {
            data,
            expiry: new Date().getTime() + ttl * 1000,
            key: key
        };
        await this.cacheStore_.set(cacheData);
    }
    async get(key) {
        const value = await this.cacheStore_.get(key);
        if (value) {
            if (new Date().getTime() - value.expiry > 0) {
                await this.delete(key);
                return;
            }
            return value;
        }
    }
    async delete(key) {
        return this.cacheStore_.delete(key);
    }
}


/***/ }),

/***/ "./src/utils/compare_string.ts":
/*!*************************************!*\
  !*** ./src/utils/compare_string.ts ***!
  \*************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   compareString: () => (/* binding */ compareString)
/* harmony export */ });
const compareString = (str1, str2) => {
    return new RegExp('^' + str1 + '$', 'i').test(str2);
};


/***/ }),

/***/ "./src/utils/cron_manager.ts":
/*!***********************************!*\
  !*** ./src/utils/cron_manager.ts ***!
  \***********************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   TaskSchedulerManager: () => (/* binding */ TaskSchedulerManager)
/* harmony export */ });
const tasks = new Map;
class TaskSchedulerManager {
    constructor(app_) {
        this.app_ = app_;
    }
    start(name) {
        const cron = this.getTaskInputByName(name);
        this.startTask_(cron);
    }
    startTask_(cron) {
        const task = new cron.task(cron.name, cron.expression, this.app_);
        task.start();
        tasks.set(cron.name, {
            task: task
        });
    }
    startAll() {
        this.app_.crons.forEach(cron => {
            this.startTask_(cron);
        });
    }
    add(...values) {
        this.app_.crons = [...this.app_.crons, ...values];
    }
    execute(name) {
        const cron = this.getTaskInputByName(name);
        return new cron.task(cron.name, cron.expression).execute();
    }
    getTaskInputByName(name) {
        const cron = this.app_.crons.find(q => q.name === name);
        if (!cron) {
            throw new Error(`Cron task ${name} is not registered.`);
        }
        return cron;
    }
    getTask(name) {
        const cron = tasks.get(name);
        if (!cron) {
            throw new Error(`Cron task ${name} does not exist`);
        }
        return cron.task;
    }
    stopTask_(task) {
        task.stop();
        tasks.delete(task.name);
    }
    stop(name) {
        const cron = this.getTask(name);
        this.stopTask_(cron);
    }
    stopAll() {
        tasks.forEach(cron => {
            this.stopTask_(cron.task);
        });
    }
}


/***/ }),

/***/ "./src/utils/index.ts":
/*!****************************!*\
  !*** ./src/utils/index.ts ***!
  \****************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   CacheManager: () => (/* reexport safe */ _cache_manager__WEBPACK_IMPORTED_MODULE_7__.CacheManager),
/* harmony export */   SessionManager: () => (/* reexport safe */ _session_manager__WEBPACK_IMPORTED_MODULE_5__.SessionManager),
/* harmony export */   TaskSchedulerManager: () => (/* reexport safe */ _cron_manager__WEBPACK_IMPORTED_MODULE_6__.TaskSchedulerManager),
/* harmony export */   compareString: () => (/* reexport safe */ _compare_string__WEBPACK_IMPORTED_MODULE_4__.compareString),
/* harmony export */   isArray: () => (/* reexport safe */ _is_array__WEBPACK_IMPORTED_MODULE_2__.isArray),
/* harmony export */   isNull: () => (/* reexport safe */ _is_null__WEBPACK_IMPORTED_MODULE_1__.isNull),
/* harmony export */   isNullOrEmpty: () => (/* reexport safe */ _is_null_or_empty__WEBPACK_IMPORTED_MODULE_0__.isNullOrEmpty),
/* harmony export */   promiseResolve: () => (/* reexport safe */ _promise_resolve__WEBPACK_IMPORTED_MODULE_3__.promiseResolve)
/* harmony export */ });
/* harmony import */ var _is_null_or_empty__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ./is_null_or_empty */ "./src/utils/is_null_or_empty.ts");
/* harmony import */ var _is_null__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ./is_null */ "./src/utils/is_null.ts");
/* harmony import */ var _is_array__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! ./is_array */ "./src/utils/is_array.ts");
/* harmony import */ var _promise_resolve__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! ./promise_resolve */ "./src/utils/promise_resolve.ts");
/* harmony import */ var _compare_string__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! ./compare_string */ "./src/utils/compare_string.ts");
/* harmony import */ var _session_manager__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(/*! ./session_manager */ "./src/utils/session_manager.ts");
/* harmony import */ var _cron_manager__WEBPACK_IMPORTED_MODULE_6__ = __webpack_require__(/*! ./cron_manager */ "./src/utils/cron_manager.ts");
/* harmony import */ var _cache_manager__WEBPACK_IMPORTED_MODULE_7__ = __webpack_require__(/*! ./cache_manager */ "./src/utils/cache_manager.ts");










/***/ }),

/***/ "./src/utils/is_array.ts":
/*!*******************************!*\
  !*** ./src/utils/is_array.ts ***!
  \*******************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   isArray: () => (/* binding */ isArray)
/* harmony export */ });
const isArray = (value) => {
    return Array.isArray(value);
};


/***/ }),

/***/ "./src/utils/is_null.ts":
/*!******************************!*\
  !*** ./src/utils/is_null.ts ***!
  \******************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   isNull: () => (/* binding */ isNull)
/* harmony export */ });
const isNull = (value) => {
    return value == null;
};


/***/ }),

/***/ "./src/utils/is_null_or_empty.ts":
/*!***************************************!*\
  !*** ./src/utils/is_null_or_empty.ts ***!
  \***************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   isNullOrEmpty: () => (/* binding */ isNullOrEmpty)
/* harmony export */ });
const isNullOrEmpty = (value) => {
    return value == null || value.length === 0;
};


/***/ }),

/***/ "./src/utils/promise_resolve.ts":
/*!**************************************!*\
  !*** ./src/utils/promise_resolve.ts ***!
  \**************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   promiseResolve: () => (/* binding */ promiseResolve)
/* harmony export */ });
const promiseResolve = (value) => {
    return Promise.resolve(value);
};


/***/ }),

/***/ "./src/utils/session_manager.ts":
/*!**************************************!*\
  !*** ./src/utils/session_manager.ts ***!
  \**************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   SessionManager: () => (/* binding */ SessionManager)
/* harmony export */ });
/* harmony import */ var uniqid__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! uniqid */ "uniqid");
/* harmony import */ var uniqid__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(uniqid__WEBPACK_IMPORTED_MODULE_0__);

class SessionManager {
    constructor(cookie, appGlobal_) {
        this.appGlobal_ = appGlobal_;
        this.sessionId = cookie.cookieCollection[appGlobal_['appSessionIdentifier_']];
        this.sessionStore = new appGlobal_.sessionStore(this.sessionId);
        this.cookie = cookie;
    }
    createSession(sessionId) {
        const now = new Date();
        this.sessionId = sessionId != null ? sessionId : uniqid__WEBPACK_IMPORTED_MODULE_0__();
        const appGlobal = this.appGlobal_;
        this.cookie.addCookie({
            name: appGlobal['appSessionIdentifier_'],
            value: this.sessionId,
            httpOnly: true,
            path: "/",
            expires: new Date(now.setMinutes(now.getMinutes() + appGlobal.sessionTimeOut)),
            maxAge: appGlobal.sessionTimeOut * 60
        });
    }
    destroy_() {
        const cookie = this.cookie.getCookie(this.appGlobal_['appSessionIdentifier_']);
        cookie.httpOnly = true;
        cookie.path = "/";
        this.cookie.removeCookie(cookie);
    }
    get(key) {
        return this.sessionStore.get(key);
    }
    isExist(key) {
        return this.sessionStore.isExist(key);
    }
    getAll() {
        return this.sessionStore.getAll();
    }
    async set(key, val) {
        const savedValue = await this.sessionStore.isAnyExist();
        if (savedValue === false) {
            this.createSession();
            this.sessionStore.sessionId = this.sessionId;
        }
        await this.sessionStore.set(key, val);
    }
    setMany(values) {
        return this.sessionStore.setMany(values);
    }
    remove(key) {
        return this.sessionStore.remove(key);
    }
    async clear() {
        // remove session values
        await this.sessionStore.clear();
        // expire cookie in browser
        this.destroy_();
    }
}


/***/ }),

/***/ "class-validator":
/*!**********************************!*\
  !*** external "class-validator" ***!
  \**********************************/
/***/ ((module) => {

module.exports = require("class-validator");

/***/ }),

/***/ "cron":
/*!***********************!*\
  !*** external "cron" ***!
  \***********************/
/***/ ((module) => {

module.exports = require("cron");

/***/ }),

/***/ "etag":
/*!***********************!*\
  !*** external "etag" ***!
  \***********************/
/***/ ((module) => {

module.exports = require("etag");

/***/ }),

/***/ "fast-content-type-parse":
/*!******************************************!*\
  !*** external "fast-content-type-parse" ***!
  \******************************************/
/***/ ((module) => {

module.exports = require("fast-content-type-parse");

/***/ }),

/***/ "fresh":
/*!************************!*\
  !*** external "fresh" ***!
  \************************/
/***/ ((module) => {

module.exports = require("fresh");

/***/ }),

/***/ "fs-extra":
/*!***************************!*\
  !*** external "fs-extra" ***!
  \***************************/
/***/ ((module) => {

module.exports = require("fs-extra");

/***/ }),

/***/ "multiparty":
/*!*****************************!*\
  !*** external "multiparty" ***!
  \*****************************/
/***/ ((module) => {

module.exports = require("multiparty");

/***/ }),

/***/ "mustache":
/*!***************************!*\
  !*** external "mustache" ***!
  \***************************/
/***/ ((module) => {

module.exports = require("mustache");

/***/ }),

/***/ "negotiator":
/*!*****************************!*\
  !*** external "negotiator" ***!
  \*****************************/
/***/ ((module) => {

module.exports = require("negotiator");

/***/ }),

/***/ "uniqid":
/*!*************************!*\
  !*** external "uniqid" ***!
  \*************************/
/***/ ((module) => {

module.exports = require("uniqid");

/***/ }),

/***/ "fs":
/*!*********************!*\
  !*** external "fs" ***!
  \*********************/
/***/ ((module) => {

module.exports = require("fs");

/***/ }),

/***/ "http":
/*!***********************!*\
  !*** external "http" ***!
  \***********************/
/***/ ((module) => {

module.exports = require("http");

/***/ }),

/***/ "path":
/*!***********************!*\
  !*** external "path" ***!
  \***********************/
/***/ ((module) => {

module.exports = require("path");

/***/ }),

/***/ "querystring":
/*!******************************!*\
  !*** external "querystring" ***!
  \******************************/
/***/ ((module) => {

module.exports = require("querystring");

/***/ }),

/***/ "url":
/*!**********************!*\
  !*** external "url" ***!
  \**********************/
/***/ ((module) => {

module.exports = require("url");

/***/ })

/******/ 	});
/************************************************************************/
/******/ 	// The module cache
/******/ 	var __webpack_module_cache__ = {};
/******/ 	
/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {
/******/ 		// Check if module is in cache
/******/ 		var cachedModule = __webpack_module_cache__[moduleId];
/******/ 		if (cachedModule !== undefined) {
/******/ 			return cachedModule.exports;
/******/ 		}
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = __webpack_module_cache__[moduleId] = {
/******/ 			// no module.id needed
/******/ 			// no module.loaded needed
/******/ 			exports: {}
/******/ 		};
/******/ 	
/******/ 		// Execute the module function
/******/ 		__webpack_modules__[moduleId](module, module.exports, __webpack_require__);
/******/ 	
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/ 	
/************************************************************************/
/******/ 	/* webpack/runtime/compat get default export */
/******/ 	(() => {
/******/ 		// getDefaultExport function for compatibility with non-harmony modules
/******/ 		__webpack_require__.n = (module) => {
/******/ 			var getter = module && module.__esModule ?
/******/ 				() => (module['default']) :
/******/ 				() => (module);
/******/ 			__webpack_require__.d(getter, { a: getter });
/******/ 			return getter;
/******/ 		};
/******/ 	})();
/******/ 	
/******/ 	/* webpack/runtime/define property getters */
/******/ 	(() => {
/******/ 		// define getter functions for harmony exports
/******/ 		__webpack_require__.d = (exports, definition) => {
/******/ 			for(var key in definition) {
/******/ 				if(__webpack_require__.o(definition, key) && !__webpack_require__.o(exports, key)) {
/******/ 					Object.defineProperty(exports, key, { enumerable: true, get: definition[key] });
/******/ 				}
/******/ 			}
/******/ 		};
/******/ 	})();
/******/ 	
/******/ 	/* webpack/runtime/hasOwnProperty shorthand */
/******/ 	(() => {
/******/ 		__webpack_require__.o = (obj, prop) => (Object.prototype.hasOwnProperty.call(obj, prop))
/******/ 	})();
/******/ 	
/******/ 	/* webpack/runtime/make namespace object */
/******/ 	(() => {
/******/ 		// define __esModule on exports
/******/ 		__webpack_require__.r = (exports) => {
/******/ 			if(typeof Symbol !== 'undefined' && Symbol.toStringTag) {
/******/ 				Object.defineProperty(exports, Symbol.toStringTag, { value: 'Module' });
/******/ 			}
/******/ 			Object.defineProperty(exports, '__esModule', { value: true });
/******/ 		};
/******/ 	})();
/******/ 	
/************************************************************************/
var __webpack_exports__ = {};
// This entry need to be wrapped in an IIFE because it need to be isolated against other modules in the chunk.
(() => {
/*!**********************!*\
  !*** ./src/index.ts ***!
  \**********************/
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   App: () => (/* reexport safe */ _models__WEBPACK_IMPORTED_MODULE_0__.App),
/* harmony export */   ComponentOption: () => (/* reexport safe */ _abstracts__WEBPACK_IMPORTED_MODULE_1__.ComponentOption),
/* harmony export */   Components: () => (/* reexport safe */ _models__WEBPACK_IMPORTED_MODULE_0__.Components),
/* harmony export */   Controller: () => (/* reexport safe */ _abstracts__WEBPACK_IMPORTED_MODULE_1__.Controller),
/* harmony export */   CookieManager: () => (/* reexport safe */ _models__WEBPACK_IMPORTED_MODULE_0__.CookieManager),
/* harmony export */   DATA_TYPE: () => (/* reexport safe */ _enums__WEBPACK_IMPORTED_MODULE_3__.DATA_TYPE),
/* harmony export */   DtoValidator: () => (/* reexport safe */ _extra__WEBPACK_IMPORTED_MODULE_6__.DtoValidator),
/* harmony export */   ERROR_TYPE: () => (/* reexport safe */ _enums__WEBPACK_IMPORTED_MODULE_3__.ERROR_TYPE),
/* harmony export */   ETAG_TYPE: () => (/* reexport safe */ _enums__WEBPACK_IMPORTED_MODULE_3__.ETAG_TYPE),
/* harmony export */   ErrorHandler: () => (/* reexport safe */ _models__WEBPACK_IMPORTED_MODULE_0__.ErrorHandler),
/* harmony export */   FileManager: () => (/* reexport safe */ _models__WEBPACK_IMPORTED_MODULE_0__.FileManager),
/* harmony export */   Fort: () => (/* reexport safe */ _models__WEBPACK_IMPORTED_MODULE_0__.Fort),
/* harmony export */   Guard: () => (/* reexport safe */ _abstracts__WEBPACK_IMPORTED_MODULE_1__.Guard),
/* harmony export */   HTTP_METHOD: () => (/* reexport safe */ _enums__WEBPACK_IMPORTED_MODULE_3__.HTTP_METHOD),
/* harmony export */   HTTP_RESULT_TYPE: () => (/* reexport safe */ _enums__WEBPACK_IMPORTED_MODULE_3__.HTTP_RESULT_TYPE),
/* harmony export */   HTTP_STATUS_CODE: () => (/* reexport safe */ _enums__WEBPACK_IMPORTED_MODULE_3__.HTTP_STATUS_CODE),
/* harmony export */   HttpCookie: () => (/* reexport safe */ _models__WEBPACK_IMPORTED_MODULE_0__.HttpCookie),
/* harmony export */   HttpFile: () => (/* reexport safe */ _models__WEBPACK_IMPORTED_MODULE_0__.HttpFile),
/* harmony export */   JsonHelper: () => (/* reexport safe */ _helpers__WEBPACK_IMPORTED_MODULE_4__.JsonHelper),
/* harmony export */   LogHelper: () => (/* reexport safe */ _helpers__WEBPACK_IMPORTED_MODULE_4__.LogHelper),
/* harmony export */   Logger: () => (/* reexport safe */ _models__WEBPACK_IMPORTED_MODULE_0__.Logger),
/* harmony export */   MIME_TYPE: () => (/* reexport safe */ _enums__WEBPACK_IMPORTED_MODULE_3__.MIME_TYPE),
/* harmony export */   MustacheViewEngine: () => (/* reexport safe */ _extra__WEBPACK_IMPORTED_MODULE_6__.MustacheViewEngine),
/* harmony export */   ResultMapper: () => (/* reexport safe */ _abstracts__WEBPACK_IMPORTED_MODULE_1__.ResultMapper),
/* harmony export */   RouteInfo: () => (/* reexport safe */ _models__WEBPACK_IMPORTED_MODULE_0__.RouteInfo),
/* harmony export */   Router: () => (/* reexport safe */ _models__WEBPACK_IMPORTED_MODULE_0__.Router),
/* harmony export */   ScheduleTask: () => (/* reexport safe */ _abstracts__WEBPACK_IMPORTED_MODULE_1__.ScheduleTask),
/* harmony export */   Shield: () => (/* reexport safe */ _abstracts__WEBPACK_IMPORTED_MODULE_1__.Shield),
/* harmony export */   ValidateBodyGuard: () => (/* reexport safe */ _helpers__WEBPACK_IMPORTED_MODULE_4__.ValidateBodyGuard),
/* harmony export */   ValidateParamGuard: () => (/* reexport safe */ _helpers__WEBPACK_IMPORTED_MODULE_4__.ValidateParamGuard),
/* harmony export */   ValidateQueryShield: () => (/* reexport safe */ _helpers__WEBPACK_IMPORTED_MODULE_4__.ValidateQueryShield),
/* harmony export */   ViewEngine: () => (/* reexport safe */ _abstracts__WEBPACK_IMPORTED_MODULE_1__.ViewEngine),
/* harmony export */   Wall: () => (/* reexport safe */ _abstracts__WEBPACK_IMPORTED_MODULE_1__.Wall),
/* harmony export */   WorkerInfo: () => (/* reexport safe */ _models__WEBPACK_IMPORTED_MODULE_0__.WorkerInfo),
/* harmony export */   XmlParser: () => (/* reexport safe */ _abstracts__WEBPACK_IMPORTED_MODULE_1__.XmlParser),
/* harmony export */   asBody: () => (/* reexport safe */ _decorators__WEBPACK_IMPORTED_MODULE_2__.asBody),
/* harmony export */   asParam: () => (/* reexport safe */ _decorators__WEBPACK_IMPORTED_MODULE_2__.asParam),
/* harmony export */   asQuery: () => (/* reexport safe */ _decorators__WEBPACK_IMPORTED_MODULE_2__.asQuery),
/* harmony export */   assign: () => (/* reexport safe */ _decorators__WEBPACK_IMPORTED_MODULE_2__.assign),
/* harmony export */   cacheFor: () => (/* reexport safe */ _decorators__WEBPACK_IMPORTED_MODULE_2__.cacheFor),
/* harmony export */   defaultWorker: () => (/* reexport safe */ _decorators__WEBPACK_IMPORTED_MODULE_2__.defaultWorker),
/* harmony export */   downloadResult: () => (/* reexport safe */ _helpers__WEBPACK_IMPORTED_MODULE_4__.downloadResult),
/* harmony export */   fileResult: () => (/* reexport safe */ _helpers__WEBPACK_IMPORTED_MODULE_4__.fileResult),
/* harmony export */   getAvailableMimeTypes: () => (/* reexport safe */ _helpers__WEBPACK_IMPORTED_MODULE_4__.getAvailableMimeTypes),
/* harmony export */   getClassName: () => (/* reexport safe */ _helpers__WEBPACK_IMPORTED_MODULE_4__.getClassName),
/* harmony export */   getDataType: () => (/* reexport safe */ _helpers__WEBPACK_IMPORTED_MODULE_4__.getDataType),
/* harmony export */   getMimeTypeFromExtension: () => (/* reexport safe */ _helpers__WEBPACK_IMPORTED_MODULE_4__.getMimeTypeFromExtension),
/* harmony export */   getMimeTypeFromFileType: () => (/* reexport safe */ _helpers__WEBPACK_IMPORTED_MODULE_4__.getMimeTypeFromFileType),
/* harmony export */   getResultBasedOnMiMe: () => (/* reexport safe */ _helpers__WEBPACK_IMPORTED_MODULE_4__.getResultBasedOnMiMe),
/* harmony export */   getViewFromFile: () => (/* reexport safe */ _helpers__WEBPACK_IMPORTED_MODULE_4__.getViewFromFile),
/* harmony export */   guards: () => (/* reexport safe */ _decorators__WEBPACK_IMPORTED_MODULE_2__.guards),
/* harmony export */   htmlResult: () => (/* reexport safe */ _helpers__WEBPACK_IMPORTED_MODULE_4__.htmlResult),
/* harmony export */   http: () => (/* reexport safe */ _decorators__WEBPACK_IMPORTED_MODULE_2__.http),
/* harmony export */   initController: () => (/* reexport safe */ _helpers__WEBPACK_IMPORTED_MODULE_4__.initController),
/* harmony export */   initGuard: () => (/* reexport safe */ _helpers__WEBPACK_IMPORTED_MODULE_4__.initGuard),
/* harmony export */   initShield: () => (/* reexport safe */ _helpers__WEBPACK_IMPORTED_MODULE_4__.initShield),
/* harmony export */   initWall: () => (/* reexport safe */ _helpers__WEBPACK_IMPORTED_MODULE_4__.initWall),
/* harmony export */   joinRoute: () => (/* reexport safe */ _helpers__WEBPACK_IMPORTED_MODULE_4__.joinRoute),
/* harmony export */   jsonResult: () => (/* reexport safe */ _helpers__WEBPACK_IMPORTED_MODULE_4__.jsonResult),
/* harmony export */   multiFormatResult: () => (/* reexport safe */ _helpers__WEBPACK_IMPORTED_MODULE_4__.multiFormatResult),
/* harmony export */   parseAndMatchRoute: () => (/* reexport safe */ _helpers__WEBPACK_IMPORTED_MODULE_4__.parseAndMatchRoute),
/* harmony export */   parseCookie: () => (/* reexport safe */ _helpers__WEBPACK_IMPORTED_MODULE_4__.parseCookie),
/* harmony export */   promise: () => (/* reexport safe */ _helpers__WEBPACK_IMPORTED_MODULE_4__.promise),
/* harmony export */   redirectResult: () => (/* reexport safe */ _helpers__WEBPACK_IMPORTED_MODULE_4__.redirectResult),
/* harmony export */   removeFirstSlash: () => (/* reexport safe */ _helpers__WEBPACK_IMPORTED_MODULE_4__.removeFirstSlash),
/* harmony export */   removeLastSlash: () => (/* reexport safe */ _helpers__WEBPACK_IMPORTED_MODULE_4__.removeLastSlash),
/* harmony export */   removeMethodAndNullFromObject: () => (/* reexport safe */ _helpers__WEBPACK_IMPORTED_MODULE_4__.removeMethodAndNullFromObject),
/* harmony export */   renderView: () => (/* reexport safe */ _helpers__WEBPACK_IMPORTED_MODULE_4__.renderView),
/* harmony export */   reverseLoop: () => (/* reexport safe */ _helpers__WEBPACK_IMPORTED_MODULE_4__.reverseLoop),
/* harmony export */   route: () => (/* reexport safe */ _decorators__WEBPACK_IMPORTED_MODULE_2__.route),
/* harmony export */   setResultMapper: () => (/* reexport safe */ _helpers__WEBPACK_IMPORTED_MODULE_4__.setResultMapper),
/* harmony export */   shields: () => (/* reexport safe */ _decorators__WEBPACK_IMPORTED_MODULE_2__.shields),
/* harmony export */   singleton: () => (/* reexport safe */ _decorators__WEBPACK_IMPORTED_MODULE_2__.singleton),
/* harmony export */   splitRoute: () => (/* reexport safe */ _helpers__WEBPACK_IMPORTED_MODULE_4__.splitRoute),
/* harmony export */   textResult: () => (/* reexport safe */ _helpers__WEBPACK_IMPORTED_MODULE_4__.textResult),
/* harmony export */   validate: () => (/* reexport safe */ _decorators__WEBPACK_IMPORTED_MODULE_2__.validate),
/* harmony export */   viewResult: () => (/* reexport safe */ _helpers__WEBPACK_IMPORTED_MODULE_4__.viewResult),
/* harmony export */   worker: () => (/* reexport safe */ _decorators__WEBPACK_IMPORTED_MODULE_2__.worker)
/* harmony export */ });
/* harmony import */ var _models__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ./models */ "./src/models/index.ts");
/* harmony import */ var _abstracts__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ./abstracts */ "./src/abstracts/index.ts");
/* harmony import */ var _decorators__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! ./decorators */ "./src/decorators/index.ts");
/* harmony import */ var _enums__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! ./enums */ "./src/enums/index.ts");
/* harmony import */ var _helpers__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! ./helpers */ "./src/helpers/index.ts");
/* harmony import */ var _types__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(/*! ./types */ "./src/types/index.ts");
/* harmony import */ var _extra__WEBPACK_IMPORTED_MODULE_6__ = __webpack_require__(/*! ./extra */ "./src/extra/index.ts");
/* harmony import */ var _interfaces__WEBPACK_IMPORTED_MODULE_7__ = __webpack_require__(/*! ./interfaces */ "./src/interfaces/index.ts");









})();

module.exports = __webpack_exports__;
/******/ })()
;
//# sourceMappingURL=fort.js.map